package battleShip_Kaan;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.BorderFactory;
import javax.swing.JPanel;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Kaan Peker
 * @version 1.0
 *
 ****************************************************************************************************
 */

/**
 Represents the spieler's own grid
 */
public class EigenesFeld extends KriegsFeld
{
	
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
    private String gridType = "selfGrid";
    private boolean isEigenesFeldListener;
    private int ANZAHL_SCHIFFE = 5;
    private int count = 0;
    private String name;
    private Point ersterPunkt = new Point(0,0);
    private Point zweiterNächsterPunkt = new Point(0,0);
    private JPanel zweitNächsteZelle = null;
    private Point drittNächsterPunkt = new Point(0,0);
    private JPanel drittNächsteZelle = null;
    private ZweiSpielerModus battleShip;
    private JPanel thePanel = new JPanel();

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
    public EigenesFeld(String name,ZweiSpielerModus battleShip)
    {
        super();
        this.name = name;
        this.battleShip = battleShip;
    }

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
    public void getJpanel(Point aPoint)
    {
        thePanel = this.getComponentAt(aPoint);
    }
    
    public void getComp2(Point aPoint)
    {
        zweitNächsteZelle = this.getComponentAt(aPoint);
    }
    
    public void getComp3(Point aPoint)
    {
        drittNächsteZelle = this.getComponentAt(aPoint);
    }
    
    protected JPanel getZelle()
    {

        JPanel ersteZelle = new JPanel();
        ersteZelle.setBorder(BorderFactory.createLineBorder(Color.blue, 2));
        ersteZelle.setPreferredSize(new Dimension(20, 20)); // for demo purposes only
        ersteZelle.setBackground(Color.black);

        ersteZelle.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                if(isEigenesFeldListener) {
                    ersterPunkt = ersteZelle.getLocation();
                    double xPos = (ersterPunkt.getX()/20+1);
                    int x = (int) xPos;
                    double yPos = (ersterPunkt.getY()/20+1);
                    int y = (int) yPos;

                    double xPos2 = (ersterPunkt.getX()/20+2);
                    int x2 = (int) xPos2;
                    double yPos2 = (ersterPunkt.getY()/20+1);
                    int y2 = (int) yPos2;

                    double xPos3 = (ersterPunkt.getX()/20+3);
                    int x3 = (int) xPos3;
                    double yPos3 = (ersterPunkt.getY()/20+1);
                    int y3 = (int) yPos3;


                    System.out.print("\nLocation (X: " + x + " Y: " + y + ")");

                    zweiterNächsterPunkt = new Point((int)(ersterPunkt.getX()+20),(int)(ersterPunkt.getY()));
                    drittNächsterPunkt = new Point((int)(ersterPunkt.getX()+40),(int)(ersterPunkt.getY()));
                    Koordinaten a = new Koordinaten(x,y);
                    Koordinaten b = new Koordinaten(x2,y2);
                    Koordinaten c = new Koordinaten(x3,y3);

                    getComp2(zweiterNächsterPunkt);
                    getComp3(drittNächsterPunkt);

                    if(name.equals("Player1")){
                        battleShip.getSpieler1Daten().addShip(a,b,c); // Create new ship object
                        draw();
                    }
                    if(name.equals("Player2")){
                        battleShip.getSpieler2Daten().addShip(a,b,c); // Create new ship object
                        draw();
                    }
                }
            }
        });
        return ersteZelle;
    }
    
    public void setEigenesFeldListener (boolean eigenesFeldListener)
    {
        this.isEigenesFeldListener = eigenesFeldListener;
    }

    public void draw()
    {

        int[][] temp=null;
        
        
        if(name.equals("Player1"))
        {
            temp = battleShip.getSpieler1Daten().getEigeneDaten();
        }
        else if(name.equals("Player2"))
        {
            temp = battleShip.getSpieler2Daten().getEigeneDaten();
        }

        for (int i = 0; i < 11; i++)
        {
            for (int j = 0; j < 11; j++)
            {
                if(temp[i][j]==1)
                {
                    int x = NummerZuPanel(i);
                    int y = NummerZuPanel(j);

                    Point p = new Point(x,y);
                    getJpanel(p);
                    thePanel.setBackground(Color.CYAN);
                }
                
               if(temp[i][j]==0)
               {
                   int x = NummerZuPanel(i);
                   int y = NummerZuPanel(j);
                   System.out.println("\ninside black "+x +"      "+ y);

                   Point p = new Point(Math.abs(x),Math.abs(y));
                   getJpanel(p);

                   thePanel.setBackground(Color.BLACK);

                }
            }
        }
    }
    
    public int NummerZuPanel(int s)
    {
        int temp = (s-1)*20;
        return temp;
    }

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
    public boolean getSelfGridListener()
    {
        return isEigenesFeldListener;
    }
    public String getGridType(){
        return gridType;
    }
    
	// -------------------------------------------------------------------------------------
	// TOSTRING
    
	// -------- Ende der Klasse 
}