package battleShip_Kaan;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

public class SpielerBildschirm extends JFrame
{
	
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
    int groesse;
    boolean isSpielanfangSpieler1 = true;
    boolean isSpielanfangSpieler2 = true;
    ZweiSpielerModus zweispielermodus;
    private JLabel eigenesSchiffGesunken;
    JLabel anfangsSchiff;
    private JLabel gegnerSchiffGesunken;

    
	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
    public SpielerBildschirm(String name, boolean show,ZweiSpielerModus zweispielermodus)
    {
        super(name);
        this.zweispielermodus = zweispielermodus;
        this.setLayout(new BorderLayout());
        this.add(new EigenesFeld(name,zweispielermodus), BorderLayout.EAST);
        this.add(new AngriffsFeld(name,zweispielermodus,this), BorderLayout.WEST);
        this.add(new JLabel(name), BorderLayout.NORTH);

        JButton next = new JButton("next");

        Box verticalBox = Box.createVerticalBox();

        Box horizontalBox0 = Box.createHorizontalBox();
        horizontalBox0.add(new JLabel("Status for: "+name));
        verticalBox.add(horizontalBox0, BorderLayout.WEST);

        Box horizontalBox1 = Box.createHorizontalBox();
        horizontalBox1.add(new JLabel("Own ships: "));
        anfangsSchiff = new JLabel(""+Integer.toString(groesse));
        horizontalBox1.add(anfangsSchiff);
        verticalBox.add(horizontalBox1, BorderLayout.SOUTH);

        Box horizontalBox2 = Box.createHorizontalBox();
        horizontalBox2.add(new JLabel("Own ships sunk: "));
        setEigenesSchiffGesunken(new JLabel(""+Integer.toString(groesse)));
        horizontalBox2.add(getEigenesSchiffGesunken());
        verticalBox.add(horizontalBox2, BorderLayout.EAST);

        Box horizontalBox3 = Box.createHorizontalBox();
        horizontalBox3.add(new JLabel("Enemy's ships sunk: "));
        setGegnerSchiffGesunken(new JLabel(""+Integer.toString(groesse)));
        horizontalBox3.add(getGegnerSchiffGesunken());
        verticalBox.add(horizontalBox3);

        next.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {

                if(name.equals("Player1"))
                {
                    groesse = zweispielermodus.getSpieler1Daten().getFlotte().size();
                    if(isSpielanfangSpieler1)
                    {
                        anfangsSchiff.setText(Integer.toString(groesse));
                        isSpielanfangSpieler1 = false;
                    }
                    if(!isSpielanfangSpieler1)
                    {
                    	zweispielermodus.spieler1Zug();
                    }
                    unsichtbar();
                    zweispielermodus.getSpieler2().sichtbar();
                }
                if(name.equals("Player2")){
                    groesse = zweispielermodus.getSpieler2Daten().getFlotte().size();
                    if(isSpielanfangSpieler2)
                    {
                        anfangsSchiff.setText(Integer.toString(groesse));
                        isSpielanfangSpieler2 = false;
                    }
                    if(!isSpielanfangSpieler2)
                    {
                    	zweispielermodus.spieler2Zug();
                    }
                    unsichtbar();
                    zweispielermodus.getSpieler1().sichtbar();
                }
            }
        });
        this.add(next, BorderLayout.CENTER);
        this.add(verticalBox, BorderLayout.SOUTH);
        this.pack();
        this.setVisible(show);
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }

    
	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
    public void sichtbar()
    {
        this.setVisible(true);
    }

    public void unsichtbar()
    {

        this.setVisible(false);
    }

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
    /**
     * TODO Beschreibe die Funktion der Methode, alle Parameter und den Rückgabewert
     *
     * @return Das Eigene Feld
     */
    public EigenesFeld getEigenesFeld()
    {

        for(Component child : this.getContentPane().getComponents()){

            if(child instanceof EigenesFeld )
            {
                return (EigenesFeld)child;
            }
        }
        return null;
    }

    public AngriffsFeld getAngriffsFeld()
    {
        for(Component child : this.getContentPane().getComponents())
        {
            if(child instanceof AngriffsFeld )
            {
                return (AngriffsFeld) child;
            }

        }
        return null;
    }
    public JButton getNextButton()
    {
        for(Component child : this.getContentPane().getComponents())
        {
            if(child instanceof JButton )
            {
                return (JButton) child;
            }

        }
        return null;
    }
    
    
    public boolean isSpielanfangSpieler2()
    {
        return isSpielanfangSpieler2;
    }

	/**
	 * @return the enemyShipSunk
	 */
	public JLabel getGegnerSchiffGesunken()
	{
		return gegnerSchiffGesunken;
	}

	/**
	 * @param gegnerSchiff Das gegnerische Schiff, das gesunken wird
	 */
	public void setGegnerSchiffGesunken(JLabel gegnerSchiff)
	{
		gegnerSchiffGesunken = gegnerSchiff;
	}

	/**
	 * @return the ownShipSunk
	 */
	public JLabel getEigenesSchiffGesunken()
	{
		return eigenesSchiffGesunken;
	}

	/**
	 * @param eigenesSchiff the ownShipSunk to set
	 */
	public void setEigenesSchiffGesunken(JLabel eigenesSchiff)
	{
		eigenesSchiffGesunken = eigenesSchiff;
	}
	
	// -------------------------------------------------------------------------------------
	// TOSTRING
	
	// -------- Ende der Klasse 
}