package game;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import java.awt.Toolkit;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JRadioButton;
import javax.swing.ButtonGroup;
import java.awt.Color;

/****************************************************************************************************
 * JFrame, oeffnet ein Menu, Schwierigkeitsgrad Auswahl, Spiel starten
 * 
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Main_Menu extends JFrame
{
	/**
	 * Integer Schwierigkeit: 0 - Leicht, 1 - Mittel, 2 - Schwer
	 */
	private int               difficulty  = 1;

	private JPanel            contentPane;
	private final ButtonGroup buttonGroup = new ButtonGroup();
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen

	/**
	 * Launch the application.
	 */
	public static void main(String[] args)
	{
		EventQueue.invokeLater(new Runnable()
		{
			public void run()
			{
				try
				{
					Main_Menu frame = new Main_Menu();
					frame.setVisible(true);
				} catch (Exception e)
				{
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public Main_Menu()
	{
		setIconImage(Toolkit.getDefaultToolkit().getImage(Main_Menu.class.getResource("/images/klo.png")));
		setResizable(false);
		setTitle("Kanalisations Spiel");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 395, 305);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);

		JPanel panel = new JPanel();
		contentPane.add(panel, BorderLayout.CENTER);
		panel.setLayout(null);

		/**
		 * Knopf zum oeffnen der Rangliste
		 */
		JButton btn_Leaderboard = new JButton("Leaderboard");
		btn_Leaderboard.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				// TODO: Leaderboard öffnen
			}
		});
		btn_Leaderboard.setBounds(10, 86, 359, 64);
		btn_Leaderboard.setEnabled(false);
		panel.add(btn_Leaderboard);

		/**
		 * Knopf zum toggeln der Musik
		 */
		JButton btn_Music = new JButton("Musik: On");
		btn_Music.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				// TODO: toggleMusic();
			}
		});
		btn_Music.setBounds(10, 151, 180, 64);
		btn_Music.setEnabled(false);
		panel.add(btn_Music);

		/**
		 * Knopf zum toggeln der Effekte
		 */
		JButton btn_Effects = new JButton("Effekte: On");
		btn_Effects.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				// TODO: toggleEffects();
			}
		});
		btn_Effects.setBounds(189, 151, 180, 64);
		btn_Effects.setEnabled(false);
		panel.add(btn_Effects);
		
		/**
		 * JRadioButton zur Auswahl der Schwierigkeit: Leicht
		 */
		JRadioButton rdbtn_Leicht    = new JRadioButton("Leicht");
		rdbtn_Leicht.setForeground(Color.WHITE);
		buttonGroup.add(rdbtn_Leicht);
		rdbtn_Leicht.setBounds(20, 222, 109, 23);
		rdbtn_Leicht.setOpaque(false);
		panel.add(rdbtn_Leicht);

		/**
		 * JRadioButton zur Auswahl der Schwierigkeit: Mittel
		 */
		JRadioButton rdbtn_Mittel = new JRadioButton("Mittel");
		rdbtn_Mittel.setForeground(Color.WHITE);
		rdbtn_Mittel.setSelected(true);
		buttonGroup.add(rdbtn_Mittel);
		rdbtn_Mittel.setBounds(131, 222, 109, 23);
		rdbtn_Mittel.setOpaque(false);
		panel.add(rdbtn_Mittel);

		/**
		 * JRadioButton zur Auswahl der Schwierigkeit: Schwer
		 */
		JRadioButton rdbtn_Schwer = new JRadioButton("Schwer");
		rdbtn_Schwer.setForeground(Color.WHITE);
		buttonGroup.add(rdbtn_Schwer);
		rdbtn_Schwer.setBounds(242, 222, 109, 23);
		rdbtn_Schwer.setOpaque(false);
		panel.add(rdbtn_Schwer);

		/**
		 * Knopf zum starten des Spiel
		 */
		JButton btn_Play = new JButton("Spielen");
		btn_Play.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				if (rdbtn_Leicht.isSelected())
					difficulty = 0;
				else if (rdbtn_Mittel.isSelected())
					difficulty = 1;
				if (rdbtn_Schwer.isSelected())
					difficulty = 2;
				Main_Game.main(difficulty, null);
				setVisible(false);
			}
		});
		btn_Play.setBounds(10, 11, 359, 64);
		panel.add(btn_Play);

		JLabel Placeholder_Background = new JLabel("");
		Placeholder_Background.setBounds(0, 0, 379, 283);
		panel.add(Placeholder_Background);
		ImageIcon    backgroundImage = new ImageIcon("src\\images\\background.jpg");
		Placeholder_Background.setIcon(backgroundImage);
	}
}
