package game;

import javax.swing.JLabel;

/****************************************************************************************************
 * Abstract class der Rohre, extends JLabel
 * 
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public abstract class Pipe extends JLabel
{
	/**
	 * In welche Richtung das Rohr schaut
	 */
	protected int direction = 0;

	/**
	 * Malt das Rohr mit der Richtung
	 */
	public abstract void paint(int direction);

	/**
	 * Dreht das Rohr nach links
	 */
	public void leftRotate()
	{
		if (direction == 0)
			direction = 3;
		else if (direction <= 3)
			direction--;

		paint(direction);
	}

	/**
	 * Dreht das Rohr nach rechts
	 */
	public void rightRotate()
	{
		if (direction == 3)
			direction = 0;
		else if (direction >= 0)
			direction++;

		paint(direction);
	}

	/**
	 * @return direction
	 */
	public int getDirection()
	{
		return direction;
	}

	/**
	 * Setzt die Richtung des Rohres
	 *
	 * @param direction In welche Richtung das Rohr schaut
	 */
	public void setDirection(int direction)
	{
		if (direction >= 0 && direction <= 3)
			this.direction = direction;
		else
			throw new IllegalArgumentException("Ungueltige direction");
	}
}
