package game;

/****************************************************************************************************
 * 
 * Interface für Projekt Kanalisationsspiel
 *
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public interface _ISpielfeld
{
	/**
	 * Erstellt die Pipes, nach der Vorgabe in Levels.txt
	 */
	public abstract void createPipes();

	/**
	 * Loescht alle Rohre, die momentan am Bildschirm sind
	 */
	public abstract void removePipes();

	/**
	 * Wird ausgefuehrt, wenn das Spiel verloren wurde Oeffnet ein JOptionPane bevor
	 * das Spiel beendet wird
	 */
	public abstract void lost();

	/**
	 * Wird ausgefuehrt, wenn das Spiel gewonnen wurde Das naechste Level wird
	 * gestartet
	 */
	public abstract void won();

	/**
	 * Sobald der Timer abgelaufen ist, wird diese Methode ausgefuehrt Ueberprueft,
	 * ob die momentane Konfiguration dieselbe ist, wie die Loesung
	 */
	public abstract void waterFlows();

	/**
	 * @return die momentane Konfiguration der Rohre
	 */
	public abstract String getPath();

	/**
	 * @return die Loesungen der Level
	 */
	public abstract String[] getSolution();

	/**
	 * startet den Timer, um die Zeit ablaufen zu lassen
	 */
	public abstract void start();

	/**
	 * @return die Konfiguration zur Erstellung der Level
	 */
	public abstract String[] getLevels();
}
