package battleShip_Kaan;


import java.awt.Color;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.BorderFactory;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger isAngriffsFeldListener
 * @version 1.0
 *
 ****************************************************************************************************
 */

/**
 * Represents the spieler's own grid
 */
public class AngriffsFeld extends KriegsFeld
{

	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String            name;
	private int               gegnerSchiffeGesunkenSpieler1 = 0;
	private int               gegnerSchiffeGesunkenSpieler2 = 0;
	private boolean           isAngriffsFeldListener;
	private ZweiSpielerModus  zweispielermodus;
	private SpielerBildschirm spieler;
	private JPanel            thePanel                      = null;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public AngriffsFeld(String name, ZweiSpielerModus zweispielermodus, SpielerBildschirm spieler)
	{
		super();
		this.name             = name;
		this.spieler          = spieler;
		this.zweispielermodus = zweispielermodus;
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	protected JPanel getZelle()
	{
		JPanel panel = new JPanel();
		panel.setBackground(Color.black);
		panel.setBorder(BorderFactory.createLineBorder(Color.red, 2));
		panel.setPreferredSize(new Dimension(20, 20)); // for demo purposes only

		panel.addMouseListener(new MouseAdapter()
		{
			@Override
			public void mouseClicked(MouseEvent e)
			{
				if (isAngriffsFeldListener)
				{

					Point  i    = panel.getLocation();
					double xPos = (i.getX() / 20 + 1);
					int    x    = (int) xPos;
					double yPos = (i.getY() / 20 + 1);
					int    y    = (int) yPos;

					if (name.equals("Player1"))
					{
						if (!zweispielermodus.getSpielerDran())
						{
							zweispielermodus.setSpielerDran(true);
							Koordinaten hit = new Koordinaten(x, y);
							zweispielermodus.getSpieler2Daten().attackShip(hit);

							boolean success = zweispielermodus.getSpieler2Daten().isHit(hit);
							if (success)
							{
								zweispielermodus.getSpieler1Daten().setAngriffsDaten(x, y, "success");
								draw();
							}
							else
							{
								zweispielermodus.getSpieler1Daten().setAngriffsDaten(x, y, "failure");
								draw();
							}

							boolean isSunk = zweispielermodus.getSpieler2Daten().isGesunken(hit);
							if (isSunk)
							{
								gegnerSchiffeGesunkenSpieler1++;
								zweispielermodus.getSpieler1().getGegnerSchiffGesunken()
										.setText(Integer.toString(gegnerSchiffeGesunkenSpieler1));
								JOptionPane.showMessageDialog(panel,
										"Ein Schiff von Spieler 2 gesunken! Gratuliere!\nOK druecken, um den Zug zu beenden");
								spieler.unsichtbar();
								zweispielermodus.getSpieler2().sichtbar();
								String ownShipSunkPlayer2 = Integer
										.toString(zweispielermodus.getSpieler2Daten().getAnzEigeneSchiffeGesunken());
								zweispielermodus.getSpieler2().getEigenesSchiffGesunken().setText(ownShipSunkPlayer2);
							}
						}
						boolean lost = zweispielermodus.getSpieler2Daten().isSpielerVerloren();
						if (lost)
						{
							zweispielermodus.setStatus(zweispielermodus.getSpielEnde());
							JOptionPane.showMessageDialog(panel,
									"Du (Spieler 1) hast gewonnen! Gratuliere!\nOK druecken, um das Spiel zu verlassen");
							zweispielermodus.spieler1Zug();
						}

					}
					if (name.equals("Player2"))
					{
						if (zweispielermodus.getSpielerDran())
						{
							zweispielermodus.setSpielerDran(false);
							Koordinaten getroffen = new Koordinaten(x, y);
							zweispielermodus.getSpieler1Daten().attackShip(getroffen);

							boolean success = zweispielermodus.getSpieler1Daten().isHit(getroffen);
							if (success)
							{
								System.out.print("spieler2 angriff");
								zweispielermodus.getSpieler2Daten().setAngriffsDaten(x, y, "success");
								draw();
							}
							else
							{
								zweispielermodus.getSpieler2Daten().setAngriffsDaten(x, y, "failure");
								draw();
							}

							boolean isSunk = zweispielermodus.getSpieler1Daten().isGesunken(getroffen);
							if (isSunk)
							{
								gegnerSchiffeGesunkenSpieler2++;
								zweispielermodus.getSpieler2().getGegnerSchiffGesunken()
										.setText(Integer.toString(gegnerSchiffeGesunkenSpieler2));
								JOptionPane.showMessageDialog(panel,
										"Ein Schiff von Spieler 1 gesunken! Gratuliere!\nOK druecken, um den Zug zu beenden");
								spieler.unsichtbar();
								zweispielermodus.getSpieler1().sichtbar();
								String ownShipSunkPlayer1 = Integer
										.toString(zweispielermodus.getSpieler1Daten().getAnzEigeneSchiffeGesunken());
								zweispielermodus.getSpieler1().getEigenesSchiffGesunken().setText(ownShipSunkPlayer1);
							}
						}
						boolean lost = zweispielermodus.getSpieler1Daten().isSpielerVerloren();
						if (lost)
						{
							zweispielermodus.setStatus(zweispielermodus.getSpielEnde());
							JOptionPane.showMessageDialog(panel,
									"Du (Spieler 2) hast gewonnen! Gratuliere!\nOK druecken, um das Spiel zu verlassen");
							zweispielermodus.spieler2Zug();
						}
					}
				}


			}
		});

		return panel;
	}

	public void setAngriffsFeldListener(boolean angriffsFeldListener)
	{
		this.isAngriffsFeldListener = angriffsFeldListener;
	}


	public void getJpanel(Point aPoint)
	{
		thePanel = this.getComponentAt(aPoint);
	}

	public void draw()
	{

		int[][] temp = null;


		if (name.equals("Player1"))
		{
			temp = zweispielermodus.getSpieler1Daten().getAngriffsDaten();
		}
		else if (name.equals("Player2"))
		{
			temp = zweispielermodus.getSpieler2Daten().getAngriffsDaten();
		}

		for (int i = 0; i < 11; i++)
		{
			for (int j = 0; j < 11; j++)
			{
				if (temp[i][j] == 1)
				{
					int   x = NummerZuPanel(i);
					int   y = NummerZuPanel(j);

					Point p = new Point(x, y);
					getJpanel(p);
					thePanel.setBackground(Color.GREEN);
				}

				if (temp[i][j] == 2)
				{
					int   x = NummerZuPanel(i);
					int   y = NummerZuPanel(j);

					Point p = new Point(x, y);
					getJpanel(p);
					thePanel.setBackground(Color.WHITE);
				}
			}
		}
	}

	public int NummerZuPanel(int s)
	{
		int temp = (s - 1) * 20;
		return temp;
	}

	public boolean getAngriffsFeldListener()
	{
		return isAngriffsFeldListener;
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER

	// -------------------------------------------------------------------------------------
	// TOSTRING

	// -------- Ende der Klasse
}