package battleShip_Kaan;

import java.util.ArrayList;
import java.util.Iterator;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

public class Spieler
{
	
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
    private SpielerBildschirm spieler;
    private int[][] angriffsDaten = new int[11][11];
    private int[][] eigeneDaten = new int[11][11];
    private int anzSchiffeGesunken = 0;
    private ArrayList<Schiff> flotte = new ArrayList<>();

    
	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
    Spieler( SpielerBildschirm spieler)
    {
        this.spieler = spieler;
    }

    /*All the adding and deleting data methods */

    // Creates a new ship and adds vertical or horizontal ship to the fleet array
    public void addShip(Koordinaten a,Koordinaten b,Koordinaten c)
    {

        if(isKante(a, b, c))
        {
            System.out.print("\nPreventing adding a ship: fleet is full or user clicked too close to the edge");
        }
        else
        {
            if (isUeberlapptAmDrehpunkt(a, b, c) )
            {
                if(isUeberlapptAmDrehpunkt(a,b,c) && !isSchiffImWeg(a,b,c))
                {
                    neuesVertikalesSchiff(a, b, c);
                }
                else
                {
                    System.out.print("\nyou should only click first block to rotate");
                }

            } else if(schiffeUebrig() < 5)
            {
                flotte.add(new Schiff(a, b, c));
                setEigeneDaten(a, b, c);
            }
        }
    }

    //remove ship from fleet array
    public void loescheSchiff(Koordinaten a, Koordinaten b, Koordinaten c)
    {
        Schiff temp = new Schiff(a, b, c);
        for (int i = 0; i < flotte.size(); i++)
        {
            if (flotte.get(i).vergleichSchiffe(temp))
            {
                flotte.remove(i);
            }
        }
    }

    //remove ships from selfData table
    public void loescheSchiffEigenesFeld(Koordinaten a, Koordinaten b, Koordinaten c)
    {
        eigeneDaten[a.getX()][a.getY()]=0;
        eigeneDaten[b.getX()][b.getY()]=0;
        eigeneDaten[c.getX()][c.getY()]=0;
    }

    //add ships to selfData table
    public void neuesSchiffEigenesFeld(Koordinaten a, Koordinaten b, Koordinaten c)
    {
        eigeneDaten[a.getX()][a.getY()]=1;
        eigeneDaten[b.getX()][b.getY()]=1;
        eigeneDaten[c.getX()][c.getY()]=1;
    }

    //add ship vertically to selfData and fleet of ships
    public void neuesVertikalesSchiff(Koordinaten a, Koordinaten b, Koordinaten c)
    {
        Koordinaten aNew = new Koordinaten(a.getX(), a.getY());
        Koordinaten bNew = new Koordinaten(a.getX(), a.getY() + 1);
        Koordinaten cNew = new Koordinaten(a.getX(), a.getY() + 2);
        flotte.add(new Schiff(aNew, bNew, cNew));
        setEigeneDaten(aNew, bNew, cNew);
    }

    // attackShip searched goes through the array and tries to attack every point of every ship. If there is a match it will be marked in the ship object
    public void attackShip(Koordinaten hitCord)
    {
        Iterator itr = flotte.iterator();
        while (itr.hasNext()){
            Schiff temp = (Schiff)itr.next();
            temp.Treffer(hitCord); // Hit the point in the ship
        }
    }

    // returns number of ships left
    public int schiffeUebrig()
    {
        int temp = flotte.size();
        return temp;
    }

    /*All the setter methods */
    public void setAngriffsDaten(int x, int y, String result)
    {
        if(result.equals("success")){
            angriffsDaten[x][y] = 1;
        }
        else if(result.equals("failure")){
            angriffsDaten[x][y] = 2;
        }
    }


    public void setEigeneDaten(Koordinaten a, Koordinaten b, Koordinaten c)
    {
        eigeneDaten[a.getX()][a.getY()]=1;
        eigeneDaten[b.getX()][b.getY()]=1;
        eigeneDaten[c.getX()][c.getY()]=1;
    }

    /*All the getter methods */
    public int getAnzEigeneSchiffeGesunken()
    {
        return anzSchiffeGesunken;
    }

    public ArrayList<Schiff> getFlotte()
    {
        return flotte;
    }

    public int[][] getEigeneDaten()
    {
        return eigeneDaten;
    }
    public int[][] getAngriffsDaten()
    {
        return angriffsDaten;
    }

    public int getDatenVonZelle(int x, int y)
    {
        for (int i = 0; i < 11; i++) {
            for (int j = 0; j < 11; j++) {
                if(i == x && j ==y){
                    return eigeneDaten[i][j];
                }
            }
        }
        return -1;
    }

    /*All the boolean methods to check for state*/

    // isHit returns true if there is a ship at the point that was hit
    public boolean isHit(Koordinaten point)
    {
        for (int i=0;i<flotte.size();){
            Schiff temp = flotte.get(i);
            if(temp.isPunktGetroffen(point)){
                return true;
            }
            else
            {
                i++; // increase the counter if the the ship i didn't contain a point
            }
        }
        return false; // must return false because
    }

    // isPlayerLost determines if the player lost based on the fleet arraylist size
    public boolean isSpielerVerloren()
    {
        if(flotte.size()==0)
        {
            return true; // Player lost
        }
        else
        {
            return false;
        }
    }

    // Boolean method returns true if the Ship was sunk
    public boolean isGesunken(Koordinaten hitCord)
    {
        for (int i=0;i<flotte.size();)
        {
            Schiff temp = flotte.get(i);
            if(temp.istSchiffGesunken())
            {
                anzSchiffeGesunken++;
                flotte.remove(i);
                return true;
            }
            else
            {
                i++; // increase the counter if the ship wasn't sunk
            }
        }
        return false;
    }

    // check if the click to rotate is at the right place which is the the first cell
    public boolean isUeberlapptAmDrehpunkt(Koordinaten a, Koordinaten b, Koordinaten c)
    {
        boolean isA = false;
        boolean isB = false;
        boolean isC = false;

        for (int i = 0; i < 11; i++)
        {
            for (int j = 0; j < 11; j++)
            {
                if((a.getX()==i&&a.getY()==j))
                {
                    if(getDatenVonZelle(i,j) == 1)
                    {
                        isA = true;
                    }
                    else
                    {
                        isA = false;
                    }
                }
                if(b.getX()==i&&b.getY()==j)
                {
                    if(getDatenVonZelle(i,j) == 1)
                    {
                        isB = true;
                    }
                    else{
                        isB = false;
                    }
                }
                if(c.getX()==i&&c.getY()==j)
                {
                    if(getDatenVonZelle(i,j) == 1)
                    {
                        isC = true;
                    }
                    else{
                        isC = false;
                    }
                }
            }
        }
        if(isA && isB && isC)
        {
            return true;
        }
        return false;
    }

    //check if the ship is placed outside the grid
    public boolean isKante(Koordinaten a,Koordinaten b, Koordinaten c)
    {
        if(a.getX()==11||b.getX()==11||c.getX()==11 ||a.getY()==11||b.getY()==11||c.getY()==11)
        {
            return true;
        }
        return false;
    }

    // check for ships collision when ship is rotated
    public boolean isSchiffImWeg (Koordinaten a, Koordinaten b, Koordinaten c)
    {
        loescheSchiff(a,b,c);
        loescheSchiffEigenesFeld(a,b,c);

        Koordinaten aNew = new Koordinaten(a.getX(), a.getY());
        Koordinaten bNew = new Koordinaten(a.getX(), a.getY() + 1);
        Koordinaten cNew = new Koordinaten(a.getX(), a.getY() + 2);

        if(isKante(aNew,bNew,cNew))
        {
            addShip(a,b,c);
            neuesSchiffEigenesFeld(a,b,c);
            return true;
        }

        for (int i = 0; i < flotte.size(); i++)
        {
            if(flotte.get(i).getA().vergleichKord(bNew) || flotte.get(i).getB().vergleichKord(bNew) || flotte.get(i).getC().vergleichKord(bNew) ||
                    flotte.get(i).getA().vergleichKord(cNew) || flotte.get(i).getB().vergleichKord(cNew) || flotte.get(i).getC().vergleichKord(cNew))
            {
                addShip(a,b,c);
                neuesSchiffEigenesFeld(a,b,c);
                return true;
            }
        }
        return false;

    }

    // check for ships overlap with clicks
    public boolean isUeberlappt(Koordinaten a, Koordinaten b, Koordinaten c)
    {
        boolean isA = false;
        boolean isB = false;
        boolean isC = false;

        for (int i = 0; i < 11; i++)
        {
            for (int j = 0; j < 11; j++)
            {
                if((a.getX()==i&&a.getY()==j))
                {
                    if(getDatenVonZelle(i,j) == 1)
                    {
                        isA = true;
                    }
                    else{
                        isA = false;
                    }
                }
                if(b.getX()==i&&b.getY()==j)
                {
                    if(getDatenVonZelle(i,j) == 1)
                    {
                        isB = true;
                    }
                    else{
                        isB = false;
                    }
                }
                if(c.getX()==i&&c.getY()==j)
                {
                    if(getDatenVonZelle(i,j) == 1)
                    {
                        isC = true;
                    }
                    else{
                        isC = false;
                    }
                }
            }
        }
        if(isA || isB || isC)
        {
            return true;
        }
        return false;
    }

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
    
	// -------------------------------------------------------------------------------------
	// TOSTRING
    
	// -------- Ende der Klasse 

}