package caesar;

public class Substitution {

	private String alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"; 
	
	// ******************* Aufgabe 1 Beginn *****************************************
	/** 
	*  En- or decrypts the given inString with the given key based on mode
	*  @param inString: The string to be en- or decrypted
	*  @param key:	The key use for en- or decryption
	*  @param mode: Either 1 or -1. 1 selects encryption and -1 selects decryption
	*  @return The en- or dectypted text
	*/	
	public String cesar(String inString, int key, int mode) {
		StringBuilder translatedBuild = new StringBuilder();

		if (mode != 1 && mode != -1)
			throw new IllegalArgumentException("mode Angabe ungültig!");
		if (inString.isBlank())
			throw new IllegalArgumentException("inString Angabe ungültig!");
		
		// TODO: implement cesar cipher encryption and decryption
		for (int i = 0; i < inString.length(); i++)
		{
			translatedBuild.append(rotateLetter(inString.toUpperCase().charAt(i), mode * key));
		}
		
		return translatedBuild.toString();
	}

	public String vigenere(String inString, char[] key, int mode) {
		StringBuilder translatedBuild = new StringBuilder();
		
		if (mode != 1 && mode != -1)
			throw new IllegalArgumentException("mode Angabe ungültig!");
		if (inString.isBlank())
			throw new IllegalArgumentException("inString Angabe ungültig!");
		if (key.length < 1)
			throw new IllegalArgumentException("key Angabe ungültig!");

		for (int j = 0; j < inString.length(); j++)
		{
			translatedBuild.append(rotateLetter(inString.toUpperCase().charAt(j), alphabet.indexOf(key[j % key.length]) * mode));
		}

		return translatedBuild.toString();
	}

	private char rotateLetter(char inChar, int key) {
		int x = alphabet.indexOf(inChar) + key;

		x %= alphabet.length();
		if (x < 0)
			x += alphabet.length();
		else if (x >= alphabet.length()) 
			x -= alphabet.length();
		if (alphabet.indexOf(inChar) == -1)
			return inChar;
		return alphabet.charAt(x);
	}

}