package checkersGame;

import java.awt.Color;
import java.awt.Graphics;

import javax.swing.JPanel;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Cosic Mirza
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Spielfeld extends JPanel
{
	private Spielsteine[][] spielFeld  = new Spielsteine[8][8];

	private int             auswahlSpalte;
	private int             auswahlZeile;

	private int             naechsteSpalte1;
	private int             naechsteZeile;
	private int             naechsteSpalte2;

	private boolean         isSelected = false;

	public Spielfeld()
	{
		for (int spalten = 0; spalten < spielFeld.length; spalten++)
		{
			for (int zeilen = 0; zeilen < spielFeld.length; zeilen++)
			{
				if ((spalten % 2 == 0 && zeilen % 2 == 1) || (spalten % 2 == 1 && zeilen % 2 == 0))
				{
					if (zeilen < 3)
						spielFeld[spalten][zeilen] = new WeißerStein();
					else if (zeilen >= 5)
						spielFeld[spalten][zeilen] = new SchwarzerStein();
				}
			}
		}
	}

	public void paint(Graphics aG)
	{
		int x;
		int y;
		int richtung = 1;

		for (int spalten = 0; spalten < spielFeld.length; spalten++)
		{
			for (int zeilen = 0; zeilen < spielFeld.length; zeilen++)
			{

				x = spalten * 50;
				y = zeilen * 50;

				if ((spalten % 2 == 0 && zeilen % 2 == 1) || (spalten % 2 == 1 && zeilen % 2 == 0))
				{
					aG.setColor(Color.gray);
					aG.fillRect(x, y, 50, 50);
				}
				else
				{
					aG.setColor(Color.white);
					aG.fillRect(x, y, 50, 50);
				}
				aG.setColor(Color.black);
				aG.drawRect(x, y, 50, 50);
			}
		}
		for (int spalten = 0; spalten < spielFeld.length; spalten++)
		{
			for (int zeilen = 0; zeilen < spielFeld.length; zeilen++)
			{

				x = spalten * 50;
				y = zeilen * 50;

				if (spielFeld[spalten][zeilen] != null)
				{
					spielFeld[spalten][zeilen].paint(x, y, aG);

					if (spalten == auswahlSpalte && zeilen == auswahlZeile)
					{
						aG.setColor(Color.green);
						aG.fillOval(x + 10, y + 10, 30, 30);

						richtung = spielFeld[auswahlSpalte][auswahlZeile].richtung;
						int nextY = auswahlZeile + richtung;
						if (auswahlZeile + richtung > 0 && auswahlZeile + richtung < 7)
						{
							naechsteZeile = auswahlZeile + richtung;
							if (auswahlSpalte - 1 < 0)
							{
								naechsteSpalte1 = auswahlSpalte - 1;
								if (spielFeld[auswahlSpalte + 1][nextY] == null)
								{
									aG.setColor(Color.blue);
									aG.fillOval(x + 65, y + 15 + 50 * richtung, 20, 20);
								}
							}
							else if (auswahlSpalte + 1 > 7)
							{
								naechsteSpalte2 = auswahlSpalte + 1;
								if (spielFeld[auswahlSpalte - 1][nextY] == null)
								{
									aG.setColor(Color.blue);
									aG.fillOval(x - 35, y + 15 + 50 * richtung, 20, 20);
								}
							}
							else
							{
								naechsteSpalte1 = auswahlSpalte - 1;
								naechsteSpalte2 = auswahlSpalte + 1;
								aG.setColor(Color.blue);
								if (spielFeld[auswahlSpalte + 1][nextY] == null)
									aG.fillOval(x + 65, y + 15 + 50 * richtung, 20, 20);
								if (spielFeld[auswahlSpalte - 1][nextY] == null)
									aG.fillOval(x - 35, y + 15 + 50 * richtung, 20, 20);
							}
						}
					}
				}
			}
		}
	}

	public void setAuswahl(int spalte, int zeile)
	{
		if (zeile < 0 || zeile > 7)
			throw new IllegalArgumentException("Ungueltige Zeilen Angabe");
		if (spalte < 0 || spalte > 7)
			throw new IllegalArgumentException("Ungueltige Zeilen Angabe");

		if (isSelected)
		{
			move(auswahlSpalte, auswahlZeile, spalte, zeile);
		}

		else if (spielFeld[spalte][zeile] != null)
		{
			auswahlSpalte = spalte;
			auswahlZeile  = zeile;

			isSelected    = true;

			paint(this.getGraphics());
		}
	}

	public void move(int vorherSpalte, int vorherZeile, int nachherSpalte, int nachherZeile)
	{
		if (nachherZeile == naechsteZeile && (nachherSpalte == naechsteSpalte1 || nachherSpalte == naechsteSpalte2))
		{
			if (spielFeld[vorherSpalte][vorherZeile] != null)
			{
				if (spielFeld[vorherSpalte][vorherZeile] instanceof SchwarzerStein
						&& spielFeld[nachherSpalte][nachherZeile] instanceof WeißerStein)
				{
					if (auswahlSpalte < vorherSpalte)
						spielFeld[nachherSpalte - 1][nachherZeile - 1] = spielFeld[vorherSpalte][vorherZeile];
					if (auswahlSpalte > vorherSpalte)
						spielFeld[nachherSpalte + 1][nachherZeile - 1] = spielFeld[vorherSpalte][vorherZeile];
					spielFeld[vorherSpalte][vorherZeile]   = null;
					spielFeld[nachherSpalte][nachherZeile] = null;
					isSelected                             = false;
				}
				else if (spielFeld[vorherSpalte][vorherZeile] instanceof WeißerStein
						&& spielFeld[nachherSpalte][nachherZeile] instanceof SchwarzerStein)
				{
					if (auswahlSpalte < vorherSpalte)
						spielFeld[nachherSpalte - 1][nachherZeile + 1] = spielFeld[vorherSpalte][vorherZeile];
					if (auswahlSpalte > vorherSpalte)
						spielFeld[nachherSpalte + 1][nachherZeile + 1] = spielFeld[vorherSpalte][vorherZeile];
					spielFeld[vorherSpalte][vorherZeile]   = null;
					spielFeld[nachherSpalte][nachherZeile] = null;
					isSelected                             = false;
				}
				// damit man seine eigenen steine nicht fressen kann
				else if (spielFeld[nachherSpalte][nachherZeile] == null)
				{
					spielFeld[nachherSpalte][nachherZeile] = spielFeld[vorherSpalte][vorherZeile];
					spielFeld[vorherSpalte][vorherZeile]   = null;
					isSelected                             = false;
				}
			}
		}
		paint(this.getGraphics());
	}

}
