package plf1;

/****************************************************************************************************
 * 
 * TODO Vererbt von Haustier
 *
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Hase extends Haustier
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String farbe;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Hase(String name, String rasse, String farbe, int alter)
	{
		super(name, rasse, alter);

		if (farbe == null)
			throw new NullPointerException("Farbe darf nicht null sein!");
		if (farbe.equals(""))
			throw new IllegalArgumentException("Farbe darf nicht leer sein!");
		this.farbe = farbe;
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	@Override
	public void frissEtwas()
	{
		System.out.printf("Hase: %s knabbert an einem Salatblatt. \n", getName());
	}

	@Override
	public void bewegeDich()
	{
		System.out.printf("Hase: %s hoppelt herum. \n", getName());
	}

	@Override
	public void gibLaut()
	{
		System.out.printf("Hase: %s quietscht. \n", getName());
	}

	public void versteckeDich()
	{
		System.out.printf("Hase: %s versteckt sicht. \n", getName());
	}

	public void streicheln()
	{
		System.out.printf("Hase: %s wird gestreichelt. \n", getName());
		versteckeDich();
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	/**
	 * @return the farbe
	 */
	public String getFarbe()
	{
		return farbe;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Hase: %s, farbe: %s", super.toString(), farbe);
	}


	// -------- Ende der Klasse
}
