package plf1;

import sew.G2D;

/****************************************************************************************************
 * 
 * TODO gibt abstrakte Methoden vor; gibt Parameter für Variablen vor
 *
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public abstract class Haustier
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String name;
	private String rasse;
	private int    alter;
	private String lieblingsFutter;
	private String picture;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Haustier(String name, String rasse, int alter)
	{
		setName(name);
		setAlter(alter);

		if (rasse == null)
			throw new NullPointerException("Rasse darf nicht null sein!");
		if (rasse.equals(""))
			throw new IllegalArgumentException("Rasse darf nicht leer sein!");
		this.rasse = rasse;
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public abstract void bewegeDich();

	public abstract void gibLaut();

	public abstract void frissEtwas();

	public void paint(int x, int y)
	{
		if (x < 0)
			throw new IllegalArgumentException("x muss mindestens 0 sein!");
		if (y < 0)
			throw new IllegalArgumentException("y muss mindestens 0 sein!");

		G2D.setVisible();

		if (picture == null)
			G2D.drawString(name, x, y, 20, this);
		else
			G2D.drawImage(picture, x, y, this);
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	public void setPicture(String picture)
	{
		// Keine Null Pointer Exception, man kann das Bild ja sonst nicht entfernen
		if (picture.equals(""))
			throw new IllegalArgumentException("Bild darf nicht leer sein!");
		this.picture = picture;
	}

	/**
	 * @return the rasse
	 */
	public String getRasse()
	{
		return rasse;
	}

	/**
	 * @return the name
	 */
	public String getName()
	{
		return name;
	}

	/**
	 * @param aName the name to set
	 */
	public void setName(String aName)
	{
		if (aName == null)
			throw new NullPointerException("Name darf nicht null sein!");
		if (aName.equals(""))
			throw new IllegalArgumentException("Name darf nicht leer sein!");
		name = aName;
	}

	/**
	 * @return the alter
	 */
	public int getAlter()
	{
		return alter;
	}

	/**
	 * @param aAlter the alter to set
	 */
	public void setAlter(int aAlter)
	{
		if (aAlter <= 0)
			throw new IllegalArgumentException("Alter muss mindestens 0 sein!");
		alter = aAlter;
	}

	/**
	 * @return the lieblingsFutter
	 */
	public String getLieblingsFutter()
	{
		return lieblingsFutter;
	}

	/**
	 * @param aLieblingsFutter the lieblingsFutter to set
	 */
	public void setLieblingsFutter(String aLieblingsFutter)
	{
		if (aLieblingsFutter == null)
			throw new NullPointerException("Lieblingsfutter darf nicht null sein!");
		if (aLieblingsFutter.equals(""))
			throw new IllegalArgumentException("Lieblingsfutter darf nicht leer sein!");
		lieblingsFutter = aLieblingsFutter;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Name: %s, Rasse: %s, Alter: %d, Lieblingsfutter: %s", name, rasse, alter,
				lieblingsFutter);
	}


	// -------- Ende der Klasse
}
