package plf1;

/****************************************************************************************************
 * 
 * TODO Vererbt von Haustier
 *
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Hund extends Haustier
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String chipID;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Hund(String name, String rasse, String chipID, int alter)
	{
		super(name, rasse, alter);

		if (chipID == null)
			throw new NullPointerException("ChipID darf nicht null sein!");
		if (chipID.equals(""))
			throw new IllegalArgumentException("ChipID darf nicht leer sein!");
		this.chipID = chipID;
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	@Override
	public void frissEtwas()
	{
		System.out.printf("Hund: %s kaut auf einem Knochen. \n", getName());
	}

	@Override
	public void bewegeDich()
	{
		System.out.printf("Hund: %s läuft herum. \n", getName());
	}

	@Override
	public void gibLaut()
	{
		System.out.printf("Hund: %s Wuff. \n", getName());
	}

	public void geheGassi()
	{
		System.out.printf("Hund: %s geht Gassi. \n", getName());
		hechle();
	}

	public void hechle()
	{
		System.out.printf("Hund: %s *hechle* streckt seine Zunge raus. \n", getName());
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	/**
	 * @return the chipID
	 */
	public String getChipID()
	{
		return chipID;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Hund: %s, chipID: %s", super.toString(), chipID);
	}

	// -------- Ende der Klasse
}
