package plf1;

import java.util.ArrayList;

import sew.SewLib;

/****************************************************************************************************
 * 
 * TODO ArrayList verwaltungsklasse
 *
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Tierheim implements _ITierheim
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	ArrayList<Haustier> tiere;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Tierheim()
	{
		tiere = new ArrayList<>();
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public void paintAlleTiere()
	{
		for (Haustier haustier : tiere)
		{
			haustier.paint(SewLib.random(0, 500), SewLib.random(0, 500));
		}
	}

	@Override
	public void neuesTierAufnehmen(Haustier aTier)
	{
		tiere.add(aTier);
	}

	@Override
	public boolean istTierImHeim(Haustier aTier)
	{
		return tiere.contains(aTier);
	}

	@Override
	public void tierEntlassen(Haustier aTier)
	{
		tiere.remove(aTier);
	}

	@Override
	public void printTierListe()
	{
		for (Haustier haustier : tiere)
		{
			System.out.printf("Haustier: %s \n", haustier.toString());
		}
	}

	@Override
	public void printHundeListe()
	{
		for (Haustier haustier : tiere)
		{
			if (haustier instanceof Hund)
				System.out.printf("Hund: %s \n", haustier.toString());
		}
	}

	@Override
	public void alleTiereFuettern()
	{
		for (Haustier haustier : tiere)
		{
			haustier.frissEtwas();
		}
	}

	@Override
	public void alleTiereBewegen()
	{
		for (Haustier haustier : tiere)
		{
			haustier.bewegeDich();
		}
	}

	@Override
	public void mitHundenGassiGehen()
	{
		for (Haustier haustier : tiere)
		{
			if (haustier instanceof Hund)
				((Hund) haustier).geheGassi();
		}
	}

	@Override
	public void alleKatzenStreicheln()
	{
		for (Haustier haustier : tiere)
		{
			if (haustier instanceof Katze)
				((Katze) haustier).streicheln();
		}
	}

	@Override
	public void alleHasenStreicheln()
	{
		for (Haustier haustier : tiere)
		{
			if (haustier instanceof Hase)
				((Hase) haustier).streicheln();
		}
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	@Override
	public int getAnzHasen()
	{
		int anz = 0;

		for (Haustier haustier : tiere)
		{
			if (haustier instanceof Hase)
				anz++;
		}

		return anz;
	}

	@Override
	public int getAnzHundeUndKatzen()
	{
		int anz = 0;

		for (Haustier haustier : tiere)
		{
			if (haustier instanceof Hund || haustier instanceof Katze)
				anz++;
		}

		return anz;
	}

	@Override
	public ArrayList<Hund> getHunde()
	{
		ArrayList<Hund> hunde = new ArrayList<>();

		for (Haustier haustier : tiere)
		{
			if (haustier instanceof Hund)
				hunde.add((Hund) haustier);
		}

		return hunde;
	}

	@Override
	public ArrayList<Katze> getKatzen()
	{
		ArrayList<Katze> katzen = new ArrayList<>();

		for (Haustier haustier : tiere)
		{
			if (haustier instanceof Katze)
				katzen.add((Katze) haustier);
		}

		return katzen;
	}

	@Override
	public ArrayList<Hase> getHasen()
	{
		ArrayList<Hase> hasen = new ArrayList<>();

		for (Haustier haustier : tiere)
		{
			if (haustier instanceof Hase)
				hasen.add((Hase) haustier);
		}

		return hasen;
	}

	@Override
	public Haustier getTier(String aName, String aRasse)
	{
		for (Haustier haustier : tiere)
		{
			if (haustier.getName() == aName && haustier.getRasse() == aRasse)
				return haustier;
		}

		return null;
	}

	@Override
	public ArrayList<Haustier> getHasenUndKatzen(String aFarbe)
	{
		ArrayList<Haustier> hasenkatzen = new ArrayList<>();

		for (Haustier haustier : tiere)
		{
			if (haustier instanceof Hase)
				if (((Hase) haustier).getFarbe() == aFarbe)
					hasenkatzen.add(haustier);
			if (haustier instanceof Katze)
				if (((Katze) haustier).getFarbe() == aFarbe)
					hasenkatzen.add(haustier);
		}

		return hasenkatzen;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING



	// -------- Ende der Klasse
}
