package plf1;

import java.util.ArrayList;


/****************************************************************************************************
 * 
 * Implementiere alle Methoden dieses Interfaces
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public interface _ITierheim
{

	/** --------------------------------------------------------------------------------<br>
	 * Ein neues Tier wird in dem Tierheim hinzugefügt (Geboren, freigelassen, etc.)
	 * 
	 * @param aTier		Referenz auf das Tier, welches hinzugefügt werden soll
	 */
	void neuesTierAufnehmen(Haustier aTier);

	/** --------------------------------------------------------------------------------<br>
	 * Prüft, ob ein Tier im Tierheim bereits vorhanden ist.
	 * 
	 * @param aTier		Referenz auf das Tier, welches gesucht werden soll
	 * @return			true, falls im Tierheim gefunden
	 */
	boolean istTierImHeim(Haustier aTier);

	/** --------------------------------------------------------------------------------<br>
	 * Wenn ein Tier freigelassen wird, muss es aus dem Tierheim entfernt werden.
	 * 
	 * @param aTier		Referenz auf das Tier, welches entfernt werden soll
	 */
	void tierEntlassen(Haustier aTier);

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Tiere in der Konsole ausgeben
	 */
	void printTierListe();

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Hunde in der Konsole ausgeben
	 */
	void printHundeListe();

	/** --------------------------------------------------------------------------------<br>
	 * Alle Tiere im Tierheim füttern
	 */
	void alleTiereFuettern();

	/** --------------------------------------------------------------------------------<br>
	 * Alle Tiere im Tierheim bewegen
	 */
	void alleTiereBewegen();

	/** --------------------------------------------------------------------------------<br>
	 * Mit allen Hunden gassi-gehen
	 * 
	 */
	void mitHundenGassiGehen();

	/** --------------------------------------------------------------------------------<br>
	 * Alle Katzen streicheln
	 * 
	 */
	void alleKatzenStreicheln();

	/** --------------------------------------------------------------------------------<br>
	 * Alle Hasen streicheln
	 * 
	 */
	void alleHasenStreicheln();

	/** --------------------------------------------------------------------------------<br>
	 * Ermittelt die Anzahl der Tiere einer bestimmten Gattung.
	 * 
	 * @return  Anzahl der Tiere einer bestimmten Gattung
	 */
	int getAnzHasen();

	int getAnzHundeUndKatzen();

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Hunde im Tierheim
	 * 
	 * @return	Liste aller Hunde
	 */
	ArrayList<Hund> getHunde();

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Katzen im Tierheim
	 * 
	 * @return	Liste aller Katzen
	 */
	ArrayList<Katze> getKatzen();

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Hasen im Tierheim
	 * 
	 * @return	Liste aller Hasen
	 */
	ArrayList<Hase> getHasen();

	/** --------------------------------------------------------------------------------<br>
	 * Sucht das Tier mit einem bestimmten Namen und einer bestimmten Rasse.
	 *
	 * @param aName		Name des Tieres
	 * @param aRasse	Rasse des Tieres
	 * @return			gefundenes Tier oder null wenn nicht gefunden
	 */
	Haustier getTier(String aName, String aRasse);

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Hasen und Katzen mit einer bestimmten Farbe
	 *
	 * @param 	aFarbe		Farbe der gesuchten Hasen und Katzen
	 * @return				Liste aller gefundenen Hasen und Katzen
	 */
	ArrayList<Haustier> getHasenUndKatzen(String aFarbe);

}