package plf1;
import static org.junit.jupiter.api.Assertions.*;

import java.util.ArrayList;
import java.util.List;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.TestMethodOrder;
import org.junit.jupiter.api.MethodOrderer;
import org.junit.jupiter.api.Order;

/***************************************************************************************************
 * 
 * JUnit Test für LF1 Klasse Tierheim.
 *
 * @author Prof. Gaisberger
 * @version 1.0
 * 
 ***************************************************************************************************
 */

@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
//---------------------------------------------------------------------------------------------------
class _JUT_Tierheim
{
//	private static final String errNewNoError = "NEW: Mit diesen Parametern darf keine Exception ausgelöst werden!";
//	private static final String errNewNullPointer  = "NEW: Parameter darf nicht NULL sein (EXCEPTION fehlt): ";;
//	private static final String errNewEmptyStr = "NEW: Parameter darf kein Leerstring sein (EXCEPTION fehlt): ";
//	private static final String errReturnValue = "Ungültiger Wert! (EXCEPTION fehlt): ";
//	private static final String errArgNoError = "Dieser Wert ist gültig! Hier darf KEINE Exception ausgelöst werden: ";
	private static final String errReturnValue = "Der zurückgegeben Wert ist ungültig! Methode: ";
	private static final String errReturnListe = "Die zurückgegebene Liste ist noch nicht korrekt! Methode: ";

	// -----------------------------------------------------------------
	// Variablen für Testumgebung
	private Tierheim testHeim = new Tierheim();
	Hase             has1;
	Hund             hun1;
	Katze            kat1;
	Hase             has2;
	Hund             hun2;
	Katze            kat2;

	// -----------------------------------------------------------------
	// Wird vor jedem Testlauf aufgerufen, damit eine entsprechende
	// Testumgebung initialisiert wird
	@BeforeEach
	void setUp() throws Exception
	{
		testHeim = new Tierheim();

		has1     = new Hase("HAS01", "Hase", "Rot", 1);
		hun1     = new Hund("HUN01", "Hund", "Rot", 1);
		kat1     = new Katze("KAT01", "Katze", "Rot", 1);
		has2     = new Hase("HAS02", "Hase", "Blau", 2);
		hun2     = new Hund("HUN02", "Hund", "Blau", 2);
		kat2     = new Katze("KAT02", "Katze", "Blau", 2);

		testHeim.neuesTierAufnehmen(has1);
		testHeim.neuesTierAufnehmen(hun1);
		testHeim.neuesTierAufnehmen(kat1);
		testHeim.neuesTierAufnehmen(has2);
		testHeim.neuesTierAufnehmen(hun2);
		testHeim.neuesTierAufnehmen(kat2);
	}
				
	// -----------------------------------------------------------------
	@Test
	@Order(21)
	void testIstTierImHeim()
	{
		assertTrue(testHeim.istTierImHeim(hun2), errReturnValue + "istTierImHeim");
		assertTrue(testHeim.istTierImHeim(kat1), errReturnValue + "istTierImHeim");

		Katze neu = new Katze("KAT999", "Katze", "Grau", 99);
		assertFalse(testHeim.istTierImHeim(neu), errReturnValue + "istTierImHeim");

		testHeim.neuesTierAufnehmen(neu);
		assertTrue(testHeim.istTierImHeim(neu), errReturnValue + "neuesTierAufnehmen");
	}

	@Test
	@Order(22)
	void testTierEntlassen()
	{
		assertTrue(testHeim.istTierImHeim(hun2), errReturnValue + "istTierImHeim");
		testHeim.tierEntlassen(hun2);
		assertFalse(testHeim.istTierImHeim(hun2), errReturnValue + "istTierImHeim");
	}

	@Test
	void testPrintTierListe()
	{
		testHeim.printTierListe();
	}

	@Test
	void testPrintHundeListe()
	{
		testHeim.printHundeListe();
	}

	@Test
	void testAlleTiereFuettern()
	{
		testHeim.alleTiereFuettern();
	}

	@Test
	void testAlleTiereBewegen()
	{
		testHeim.alleTiereBewegen();
	}

	@Test
	void testMitHundenGassiGehen()
	{
		testHeim.mitHundenGassiGehen();
	}

	@Test
	void testAlleKatzenStreicheln()
	{
		testHeim.alleKatzenStreicheln();
	}

	@Test
	void testAlleHasenStreicheln()
	{
		testHeim.alleHasenStreicheln();
	}

	@Test
	void testGetAnzHasen()
	{
		assertEquals(2, testHeim.getAnzHasen(), errReturnValue + "getAnzHasen");
	}

	@Test
	void testGetAnzHundeUndKatzen()
	{
		assertEquals(4, testHeim.getAnzHundeUndKatzen(), errReturnValue + "getAnzHundeUndKatzen");
	}

	@Test
	void testGetHunde()
	{
		// ----------------------------------------------
		List<Haustier> v = new ArrayList<>();
		v.add(hun1);
		v.add(hun2);
		assertEquals(v, testHeim.getHunde(), errReturnListe + "getHunde");
	}

	@Test
	void testGetKatzen()
	{
		// ----------------------------------------------
		List<Haustier> v = new ArrayList<>();
		v.add(kat1);
		v.add(kat2);
		assertEquals(v, testHeim.getKatzen(), errReturnListe + "getKatzen");
	}

	@Test
	void testGetHasen()
	{
		// ----------------------------------------------
		List<Haustier> v = new ArrayList<>();
		v.add(has1);
		v.add(has2);
		assertEquals(v, testHeim.getHasen(), errReturnListe + "getHasen");
	}

	@Test
	void testGetTier()
	{
		assertEquals(has1, testHeim.getTier("HAS01", "Hase"), errReturnValue + "getTier!");
		assertEquals(null, testHeim.getTier("HAS1",  "Hase"), errReturnValue + "getTier!");
		assertEquals(null, testHeim.getTier("HAS01", "Hund"), errReturnValue + "getTier!");
	}

	@Test
	void testGetHasenUndKatzen()
	{
		// ----------------------------------------------
		List<Haustier> v = new ArrayList<>();
		v.add(has2);
		v.add(kat2);
		assertEquals(v, testHeim.getHasenUndKatzen("Blau"), errReturnListe + "getHasenUndKatzen");
	}
}
