package ue112_Sonnensystem;

import java.awt.Color;

import sew.G2D;

/****************************************************************************************************
 * 
 * TODO Vererbt an Sonne und Planeten
 *
 * @author Daniel
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public abstract class Himmelskoerper
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private int    x;
	private int    y;
	private String image;
	private int    size;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Himmelskoerper(String image, int size)
	{
		this.image = image;
		if (size < 0)
			throw new IllegalArgumentException("size muss größer als 0 sein!");
		this.size = size;
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public void paint()
	{
		G2D.setVisible(true);

		if (image == "umlaufbahn")
			G2D.drawOval(x - size / 2, y - size / 2, size, size, Color.BLACK, this);
		else if (image != null && image != "")
			G2D.drawImage(image, x - size / 2, y - size / 2, size, size, this);
		else
			G2D.fillOval(x - size / 2, y - size / 2, size, size, Color.YELLOW, this);
	}

	public abstract void move();

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	public int getX()
	{
		return x;
	}

	public int getY()
	{
		return y;
	}

	public void setXY(int x, int y)
	{
		this.x = x;
		this.y = y;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Himmelskoerper [x=%s, y=%s, image=%s, size=%s]", x, y, image, size);
	}

	// -------- Ende der Klasse
}
