package ue112_Sonnensystem;

import java.awt.Color;

import sew.G2D;

/****************************************************************************************************
 * 
 * TODO Planet
 *
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Planet extends Himmelskoerper
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private int            radiusUmlaufbahn;
	private double         aktposition;
	private double         v;
	private Himmelskoerper drehtSichUm;
	private Umlaufbahn     umlaufbahn;
	private boolean        showSpur;
	private Color          spurColor;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Planet(String image, int size, Himmelskoerper drehtSichUm, int radiusUmlaufbahn, double v)
	{
		super(image, size);

		if (drehtSichUm == null)
			throw new NullPointerException("");

		this.drehtSichUm = drehtSichUm;
		if (radiusUmlaufbahn < 0)
			throw new IllegalArgumentException("Der Radius muss größer 0 sein!");
		this.radiusUmlaufbahn = radiusUmlaufbahn;
		this.v                = v;

		umlaufbahn            = new Umlaufbahn(this, radiusUmlaufbahn);
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	@Override
	public void move()
	{
		aktposition += v;
		double xNeu = this.drehtSichUm.getX() + radiusUmlaufbahn * Math.cos(aktposition);
		double yNeu = this.drehtSichUm.getY() + radiusUmlaufbahn * Math.sin(aktposition);

		if (!(this.getX() == 0 && this.getY() == 0) && showSpur == true)
			G2D.drawLine(this.getX(), this.getY(), (int) xNeu, (int) yNeu, spurColor, null);

		setXY((int) xNeu, (int) yNeu);

		umlaufbahn.paint();
		paint();
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	public void setSpurColor(Color spurColor)
	{
		this.spurColor = (Color) spurColor;
	}

	public void setShowSpur(boolean showSpur)
	{
		this.showSpur = showSpur;
	}

	public Himmelskoerper getDrehtSichUm()
	{
		return drehtSichUm;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING



	// -------- Ende der Klasse
}
