package ue151_Wildtiere;

/****************************************************************************************************
 * 
 * TODO Vater klasse
 *
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public abstract class Wildtier
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String rasse;
	private String heimat;
	private int    alter;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Wildtier(String rasse, String heimat, int alter)
	{
		setAlter(alter);
		if (rasse == null)
			throw new NullPointerException("rasse darf nicht null sein!");
		if (rasse.equals(""))
			throw new IllegalArgumentException("rasse darf nicht leer sein!");

		if (heimat == null)
			throw new NullPointerException("heimat darf nicht null sein!");
		if (heimat.equals(""))
			throw new IllegalArgumentException("heimat darf nicht leer sein!");

		this.rasse  = rasse;
		this.heimat = heimat;
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public abstract void bewegeDich();

	public abstract void gibLaut();

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	/**
	 * @return the heimat
	 */
	public String getHeimat()
	{
		return heimat;
	}

	/**
	 * @return the alter
	 */
	public int getAlter()
	{
		return alter;
	}

	/**
	 * @param aAlter the alter to set
	 */
	public void setAlter(int aAlter)
	{
		if (aAlter < 0)
			throw new IllegalArgumentException("alter muss >= 0 sein!");
		alter = aAlter;
	}

	/**
	 * @return the rasse
	 */
	public String getRasse()
	{
		return rasse;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Wildtier [rasse=%s, heimat=%s, alter=%s]", rasse, heimat, alter);
	}

	// -------- Ende der Klasse
}
