package ue152_Haustiere;

/****************************************************************************************************
 * 
 * TODO Basisklasse für Haustiere
 *
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public abstract class Haustier
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String name;
	private String rasse;
	private int    alter;
	private String lieblingsFutter;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Haustier(String name, String rasse, int alter)
	{
		if (rasse == null)
			throw new NullPointerException("Rasse darf nicht null sein!");
		if (rasse.equals(""))
			throw new IllegalArgumentException("Rasse darf nicht leer sein!");

		setAlter(alter);
		setName(name);
		this.rasse = rasse;
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public abstract void bewegeDich();

	public abstract void gibLaut();

	public abstract void frissEtwas();

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	/**
	 * @return the name
	 */
	public String getName()
	{
		return name;
	}

	/**
	 * @param aName the name to set
	 */
	public void setName(String aName)
	{
		if (aName == null)
			throw new NullPointerException("Name darf nicht null sein!");
		if (aName.equals(""))
			throw new IllegalArgumentException("Name darf nicht leer sein!");

		name = aName;
	}

	/**
	 * @return the alter
	 */
	public int getAlter()
	{
		return alter;
	}

	/**
	 * @param aAlter the alter to set
	 */
	public void setAlter(int aAlter)
	{
		if (aAlter < 0)
			throw new IllegalArgumentException("Alter darf nicht kleiner 0 sein!");

		alter = aAlter;
	}

	/**
	 * @return the rasse
	 */
	public String getRasse()
	{
		return rasse;
	}

	/**
	 * @return the lieblingsFutter
	 */
	public String getLieblingsFutter()
	{
		return lieblingsFutter;
	}

	/**
	 * @param aLieblingsFutter the lieblingsFutter to set
	 */
	public void setLieblingsFutter(String aLieblingsFutter)
	{
		if (aLieblingsFutter == null)
			throw new NullPointerException("Lieblingsfutter darf nicht null sein!");
		if (aLieblingsFutter.equals(""))
			throw new IllegalArgumentException("Lieblingsfutter darf nicht leer sein!");

		lieblingsFutter = aLieblingsFutter;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Haustier [name=%s, rasse=%s, alter=%s]", name, rasse, alter);
	}

	// -------- Ende der Klasse
}
