package ue211_Fuhrpark;

import java.util.ArrayList;

/****************************************************************************************************
 * 
 * TODO ArrayListe blah blah blah
 *
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Fuhrpark implements _IFuhrpark
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String              name;
	private ArrayList<Fahrzeug> fuhrpark;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Fuhrpark(String aName)
	{
		setName(aName);

		fuhrpark = new ArrayList<>();
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	@Override
	public void setName(String aName)
	{
		if (aName == null)
			throw new NullPointerException("Name darf nicht null sein!");
		if (aName.equals(""))
			throw new IllegalArgumentException("Name darf nicht leer sein!");
		name = aName;
	}

	@Override
	public String getName()
	{
		return name;
	}

	@Override
	public void fahrzeugEinstellen(Fahrzeug aFahrzeug)
	{
		fuhrpark.add(aFahrzeug);
	}

	@Override
	public boolean istFahrzeugEingestellt(Fahrzeug aFahrzeug)
	{
		return fuhrpark.contains(aFahrzeug);
	}

	@Override
	public void fahrzeugEntfernen(Fahrzeug aFahrzeug)
	{
		fuhrpark.remove(aFahrzeug);
	}

	@Override
	public void printFahrzeugListe()
	{
		for (Fahrzeug fahrzeug : fuhrpark)
		{
			System.out.printf("Fahrzeug: %s\n", fahrzeug);
		}
	}

	@Override
	public void printAutoListe()
	{
		for (Fahrzeug fahrzeug : fuhrpark)
		{
			if (fahrzeug instanceof Auto)
				System.out.printf("Auto: %s\n", fahrzeug);
		}
	}

	@Override
	public int getAnzAutos()
	{
		int anz = 0;

		for (Fahrzeug fahrzeug : fuhrpark)
		{
			if (fahrzeug instanceof Auto)
				anz++;
		}

		return anz;
	}

	@Override
	public int getAnzCabrios()
	{
		int anz = 0;

		for (Fahrzeug fahrzeug : fuhrpark)
		{
			if (fahrzeug instanceof Cabrio)
				anz++;
		}

		return anz;
	}

	@Override
	public int getAnzLKWs()
	{
		int anz = 0;

		for (Fahrzeug fahrzeug : fuhrpark)
		{
			if (fahrzeug instanceof LKW)
				anz++;
		}

		return anz;
	}

	@Override
	public int getAnzMotorrad()
	{
		int anz = 0;

		for (Fahrzeug fahrzeug : fuhrpark)
		{
			if (fahrzeug instanceof Motorrad)
				anz++;
		}

		return anz;
	}

	@Override
	public int getAnzMopedUndMotorrad()
	{
		int anz = 0;

		for (Fahrzeug fahrzeug : fuhrpark)
		{
			if (fahrzeug instanceof Motorrad || fahrzeug instanceof Moped)
				anz++;
		}

		return anz;
	}

	@Override
	public ArrayList<Auto> getAutos()
	{
		ArrayList<Auto> autoListe = new ArrayList<>();

		for (Fahrzeug fahrzeug : fuhrpark)
		{
			if (fahrzeug instanceof Auto)
				autoListe.add((Auto) fahrzeug);
		}

		return autoListe;
	}

	@Override
	public ArrayList<Cabrio> getCabrios()
	{
		ArrayList<Cabrio> cabrioListe = new ArrayList<>();

		for (Fahrzeug fahrzeug : fuhrpark)
		{
			if (fahrzeug instanceof Cabrio)
				cabrioListe.add((Cabrio) fahrzeug);
		}

		return cabrioListe;
	}

	@Override
	public ArrayList<LKW> getLKWs()
	{
		ArrayList<LKW> lkwListe = new ArrayList<>();

		for (Fahrzeug fahrzeug : fuhrpark)
		{
			if (fahrzeug instanceof LKW)
				lkwListe.add((LKW) fahrzeug);
		}

		return lkwListe;
	}

	@Override
	public ArrayList<Motorrad> getMotorraeder()
	{
		ArrayList<Motorrad> motorradListe = new ArrayList<>();

		for (Fahrzeug fahrzeug : fuhrpark)
		{
			if (fahrzeug instanceof Motorrad)
				motorradListe.add((Motorrad) fahrzeug);
		}

		return motorradListe;
	}

	@Override
	public ArrayList<Fahrzeug> getAutosUndCabrios(char aBauart)
	{
		ArrayList<Fahrzeug> autocabListe = new ArrayList<>();

		for (Fahrzeug fahrzeug : fuhrpark)
		{
			if (fahrzeug instanceof Auto)
				if (((Auto) fahrzeug).getBauart() == aBauart)
					autocabListe.add((Auto) fahrzeug);
			if (fahrzeug instanceof Cabrio)
				if (((Cabrio) fahrzeug).getBauart() == aBauart)
					autocabListe.add((Cabrio) fahrzeug);
		}

		return autocabListe;
	}

	@Override
	public Fahrzeug getFahrzeugMitFIN(String aFIN)
	{
		for (Fahrzeug fahrzeug : fuhrpark)
		{
			if (fahrzeug.getFin() == aFIN)
				return fahrzeug;
		}
		return null;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING



	// -------- Ende der Klasse
}
