package ue212_Figurenliste;

import java.awt.Color;
import java.util.ArrayList;

import sew.SewLib;

/****************************************************************************************************
 * 
 * TODO Figurenliste
 *
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class FigurenListe implements _IFigurenListe
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private ArrayList<Figur> listeMitFiguren;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public FigurenListe()
	{
		listeMitFiguren = new ArrayList<>();
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public void neueFigurHinzufuegen(Figur figur)
	{
		listeMitFiguren.add(figur);
	}

	public boolean istFigurBereitsInDerListe(Figur figur)
	{
		if (listeMitFiguren.contains(figur))
			return true;
		else
			return false;
	}

	public void entferneFigurAusDerListe(int index)
	{
		listeMitFiguren.remove(index);
	}

	public void entferneFigurAusDerListe(Figur figur)
	{
		listeMitFiguren.remove(figur);
	}

	public void printFigurenListe()
	{
		for (Figur figur : listeMitFiguren)
		{
			System.out.printf("Figur: %s \n", figur.toString());
		}
	}

	@Override
	public void printKreisListe()
	{
		for (Figur figur : listeMitFiguren)
		{
			if (figur instanceof Kreis)
				System.out.printf("Kreis: %s \n", figur.toString());
		}
	}

	public int anzahl()
	{
		return listeMitFiguren.size();
	}

	public void paint()
	{
		for (Figur figur : listeMitFiguren)
			figur.paint();
	}

	public void paint(Class<? extends Figur> type)
	{
		for (Figur figur : listeMitFiguren)
			if (type.isInstance(figur))
				figur.paint();
	}

	public void paintKreise()
	{
		for (Figur figur : listeMitFiguren)
		{
			if (figur instanceof Kreis)
				figur.paint();
		}
	}

	public void paintQuadrate()
	{
		for (Figur figur : listeMitFiguren)
		{
			if (figur instanceof Quadrat)
				figur.paint();
		}
	}

	public void paintRechteck()
	{
		for (Figur figur : listeMitFiguren)
		{
			if (figur instanceof Rechteck)
				figur.paint();
		}
	}

	@Override
	public void alleFigurenZeichnen()
	{
		paint();
	}

	@Override
	public void alleRechteckeZeichnen()
	{
		paintRechteck();
	}

	@Override
	public void alleQuadrateZeichnen()
	{
		paintQuadrate();
	}

	@Override
	public void alleKreiseZeichnen()
	{
		paintKreise();
	}

	@Override
	public void alleFigurenAufZufaelligePosition()
	{
		for (Figur figur : listeMitFiguren)
		{
			figur.setXY(SewLib.random(0, 800), SewLib.random(0, 800));
		}
	}

	@Override
	public void alleKreiseAufZufaelligePosition()
	{
		for (Figur figur : listeMitFiguren)
		{
			if (figur instanceof Kreis)
				figur.setXY(SewLib.random(0, 800), SewLib.random(0, 800));
		}
	}

	@Override
	public void alleRechteckeZufaelligeFaerben()
	{
		for (Figur figur : listeMitFiguren)
		{
			if (figur instanceof Rechteck)
			{
				int   r   = SewLib.random(0, 255);
				int   g   = SewLib.random(0, 255);
				int   b   = SewLib.random(0, 255);
				Color col = new Color(r, g, b);

				figur.setFarbe(col);
			}
		}
	}

	@Override
	public int getAnzKreis()
	{
		int anz = 0;
		for (Figur figur : listeMitFiguren)
		{
			if (figur instanceof Kreis)
				anz++;
		}
		return anz;
	}

	@Override
	public int getAnzRechteck()
	{
		int anz = 0;
		for (Figur figur : listeMitFiguren)
		{
			if (figur instanceof Rechteck)
				anz++;
		}
		return anz;
	}

	@Override
	public int getAnzQuadrat()
	{
		int anz = 0;
		for (Figur figur : listeMitFiguren)
		{
			if (figur instanceof Quadrat)
				anz++;
		}
		return anz;
	}

	@Override
	public int getAnzRechteckUndQuadrat()
	{
		int anz = getAnzRechteck() + getAnzQuadrat();

		return anz;
	}

	@Override
	public int getAnzKreisGroesserAls(int aRadius)
	{
		int anz = 0;

		for (Figur figur : listeMitFiguren)
		{
			if (figur instanceof Kreis)
			{
				if (((Kreis) figur).getRadius() > aRadius)
					anz++;
			}
		}
		return anz;
	}

	@Override
	public ArrayList<Rechteck> getRechtecke()
	{
		ArrayList<Rechteck> listeMitRechteck = new ArrayList<>();

		for (Figur figur : listeMitFiguren)
		{
			if (figur instanceof Rechteck)
				listeMitRechteck.add((Rechteck) figur);
		}

		return listeMitRechteck;
	}

	@Override
	public ArrayList<Quadrat> getQuadrate()
	{
		ArrayList<Quadrat> listeMitQuadrat = new ArrayList<>();

		for (Figur figur : listeMitFiguren)
		{
			if (figur instanceof Quadrat)
				listeMitQuadrat.add((Quadrat) figur);
		}

		return listeMitQuadrat;
	}

	@Override
	public ArrayList<Kreis> getKreise()
	{
		ArrayList<Kreis> listeMitKreis = new ArrayList<>();

		for (Figur figur : listeMitFiguren)
		{
			if (figur instanceof Kreis)
				listeMitKreis.add((Kreis) figur);
		}

		return listeMitKreis;
	}

	@Override
	public ArrayList<Quadrat> getQuadrateGroesserAls(int aSeitenlaenge)
	{
		ArrayList<Quadrat> listeMitQuadrat = new ArrayList<>();

		for (Figur figur : listeMitFiguren)
		{
			if (figur instanceof Quadrat)
				if (((Quadrat) figur).getSeitenlaenge() > aSeitenlaenge)
					listeMitQuadrat.add((Quadrat) figur);
		}

		return listeMitQuadrat;
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER


	// -------------------------------------------------------------------------------------
	// TOSTRING



	// -------- Ende der Klasse
}
