package ue310_BMW;

import sew.G2D;

/****************************************************************************************************
 * 
 * @author Prof. Gaisberger
 * @assistant_author DanieL Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class BMW
{
	// -------------------------------------------------------------------------------------
	// INSTANZVARIABLEN
	private String typ;      // nicht null und nicht leer
	private char   bauart;   // 'S' -> Sport, 'K' -> Kombi, 'C' -> Coupe
	private String farbe;    // nicht null und nicht leer
	private int    leistung; // 0 -600PS

	private String picture;


	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR
	public BMW(String aTyp, String aFarbe, char aBauart, int aLeistung)
	{
		if (aTyp == null)
			throw new NullPointerException("Typ darf nicht null sein!");
		if (aTyp.equals(""))
			throw new IllegalArgumentException("Typ darf nicht leer sein!");

		if (aBauart != 'S' && aBauart != 'K' && aBauart != 'C')
			throw new IllegalArgumentException("Bauart muss 'S', 'K' oder 'C' sein!");

		typ    = aTyp;
		bauart = aBauart;
		setFarbe(aFarbe);
		setLeistung(aLeistung);
	}

	public void paint()
	{
		if (picture != null)
			G2D.drawImage(picture, 100, 100, this);
	}


	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	public String getTyp()
	{
		return typ;
	}

	public char getBauart()
	{
		return bauart;
	}

	public int getLeistung()
	{
		return leistung;
	}

	public void setLeistung(int aLeistung)
	{
		if (aLeistung <= 0)
			throw new IllegalArgumentException("Leistung darf nicht kleiner gleich 0 sein!");
		if (aLeistung > 600)
			throw new IllegalArgumentException("Leistung darf nicht größer 600 sein!");
		leistung = aLeistung;
	}

	public String getFarbe()
	{
		return farbe;
	}

	public void setFarbe(String aFarbe)
	{
		if (aFarbe == null)
			throw new NullPointerException("Farbe darf nicht null sein!");
		if (aFarbe.equals(""))
			throw new IllegalArgumentException("Farbe darf nicht leer sein!");

		farbe = aFarbe;
	}

	public void setPicture(String aPicture)
	{
		if (aPicture == null)
			throw new NullPointerException("Picture darf nicht null sein!");
		if (aPicture.equals(""))
			throw new IllegalArgumentException("Picture darf nicht leer sein!");
		picture = aPicture;
	}


	@Override
	public String toString()
	{
		return String.format("BMW [typ=%s, bauart=%s, farbe=%s, leistung=%s]", typ, bauart, farbe, leistung);
	}


	// -------- Ende der Klasse
}
