package ue370_Datum;

/****************************************************************************************************
 * 
 * TODO cry
 *
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Datum_RegEx implements _IDatum_RegEx
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private int                 jahr;
	private int                 monat;
	private int                 tag;

	private static final String REGEX_JJJJ     = "(19|20)[0-9][0-9]";
	private static final String REGEX_MM       = "(1[012]|0?[1-9]|)";
	private static final String REGEX_TT       = "([12][0-9]|3[01]|0?[1-9])";
	private static final String REGEX_TTMMJJJJ = REGEX_TT + "\\." + REGEX_MM + "\\." + REGEX_JJJJ;
	private static final String REGEX_JJJJMMTT = REGEX_JJJJ + "\\." + REGEX_MM + "\\." + REGEX_TT;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Datum_RegEx(String datum)
	{
		if (isValid(datum))
		{
			String[] parts = datum.split("\\.");
			int      zahl1 = Integer.parseInt(parts[0]);
			int      zahl2 = Integer.parseInt(parts[1]);
			int      zahl3 = Integer.parseInt(parts[2]);

			if (datum.matches(REGEX_JJJJMMTT))
			{
				jahr  = zahl1;
				monat = zahl2;
				tag   = zahl3;
			}
			else if (datum.matches(REGEX_TTMMJJJJ))
			{
				jahr  = zahl3;
				monat = zahl2;
				tag   = zahl1;
			}
		}
		else
			throw new IllegalArgumentException("Eingabe ungültig!");
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public static boolean isValid(String datum)
	{
		if (datum == null)
			throw new NullPointerException("Eingabe darf nicht null sein!");

		return datum.matches(REGEX_JJJJMMTT) || datum.matches(REGEX_TTMMJJJJ);
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	@Override
	public String getDatum()
	{
		return String.format("%02d.%02d.%d", tag, monat, jahr);
	}

	@Override
	public int getJahr()
	{
		return jahr;
	}

	@Override
	public int getMonat()
	{
		return monat;
	}

	@Override
	public int getTag()
	{
		return tag;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Datum_RegEx [jahr=%s, monat=%s, tag=%s]", jahr, monat, tag);
	}

	// -------- Ende der Klasse
}
