package ue370_Datum;

import static org.junit.jupiter.api.Assertions.*;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.MethodOrderer;
import org.junit.jupiter.api.Order;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.TestMethodOrder;

/****************************************************************************************************
 * 
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
//---------------------------------------------------------------------------------------------------
class _JUT_Datum_RegEx
{
	private static final String errNewNoError     = "NEW: Mit diesen Parametern darf keine Exception ausgelöst werden!";
	private static final String errNewNullPointer = "NEW: Parameter darf nicht NULL sein (EXCEPTION fehlt): ";;
//	private static final String errNewEmptyStr = "NEW: Parameter darf kein Leerstring sein (EXCEPTION fehlt): ";
	private static final String errArgIllegal     = "Ungültiger Wert! (EXCEPTION fehlt): ";
//	private static final String errArgNoError = "Dieser Wert ist gültig! Hier darf KEINE Exception ausgelöst werden: ";
	private static final String errReturnValue    = "Der zurückgegeben Wert ist ungültig! Methode: ";
//	private static final String errReturnListe = "Die zurückgegebene Liste ist noch nicht korrekt! Methode: ";

	// -------------------------------------------------------------------------------------
	@BeforeEach
	void setUp() throws Exception
	{
		// Hier nicht benötigt
	}

	// -------------------------------------------------------------------------------------
	@Test
	@Order(10)
	void testDatum()
	{
		// ------------------------------------------------------------------------------
		// Teste Konstruktor
		assertThrows(NullPointerException.class, () -> {
			new Datum_RegEx(null);
		}, errNewNullPointer);

		assertThrows(IllegalArgumentException.class, () -> {
			new Datum_RegEx("Keine Datum");
		}, errArgIllegal + "Datum");

		// Jetzt sollte alles in Ordnung sein!
		assertDoesNotThrow(() -> {
			new Datum_RegEx("5.09.2020");
		}, errNewNoError);
	}


	// -------------------------------------------------------------------------------------
	@Test
	@Order(20)
	void testGetterUndSetter()
	{
		Datum_RegEx datum = new Datum_RegEx("5.09.2020");

		assertEquals(5, datum.getTag(), errReturnValue + "getTag");
		assertEquals(9, datum.getMonat(), errReturnValue + "getMonat");
		assertEquals(2020, datum.getJahr(), errReturnValue + "getJahr");
		assertEquals("05.09.2020", datum.getDatum(), errReturnValue + "getDatum");
	}


	// -------------------------------------------------------------------------------------
	@Test
	@Order(30)
	void testIsValid()
	{
		assertThrows(NullPointerException.class, () -> {
			Datum_RegEx.isValid(null);
		}, errArgIllegal + "Darf nicht null sein!");

		assertTrue(Datum_RegEx.isValid("1.1.2020"), errReturnValue + "isValid");
		assertTrue(Datum_RegEx.isValid("1.12.1900"), errReturnValue + "isValid");
		assertTrue(Datum_RegEx.isValid("31.01.2020"), errReturnValue + "isValid");

		assertFalse(Datum_RegEx.isValid("0.1.2000"), errReturnValue + "isValid");
		assertFalse(Datum_RegEx.isValid("1.0.2012"), errReturnValue + "isValid");
		assertFalse(Datum_RegEx.isValid("0.1.2000"), errReturnValue + "isValid");
		assertFalse(Datum_RegEx.isValid("1.1.0"), errReturnValue + "isValid");
	}


	// -------------------------------------------------------------------------------------
	@Test
	@Order(31)
	void testIsValidGenauer()
	{
		// ------------------------------------------------------------------------------
		// Prüfe Datumswerte.
		// ACHTUNG: Keine Prüfung, ob 30 oder 31 Tage!!!!
		for (int j = 1900; j < 2100; j++)
		{
			for (int m = -10; m < 20; m++)
			{
				for (int t = -10; t < 40; t++)
				{
					String datum1 = String.format("%d.%d.%d", t, m, j);
					String datum2 = String.format("%d.%d.%d", j, m, t);
					String datum3 = String.format("%02d.%02d.%04d", t, m, j);
					String datum4 = String.format("%04d.%02d.%02d", j, m, t);

					if ((t >= 1 && t <= 31) && (m >= 1 && m <= 12) && (j >= 1900 && j <= 2099))
					{
						assertTrue(Datum_RegEx.isValid(datum1), errReturnValue + "isValid: " + datum1);
						assertTrue(Datum_RegEx.isValid(datum2), errReturnValue + "isValid: " + datum2);
						assertTrue(Datum_RegEx.isValid(datum3), errReturnValue + "isValid: " + datum3);
						assertTrue(Datum_RegEx.isValid(datum4), errReturnValue + "isValid: " + datum4);
					}
					else
					{
						assertFalse(Datum_RegEx.isValid(datum1), errReturnValue + "isValid: " + datum1);
						assertFalse(Datum_RegEx.isValid(datum2), errReturnValue + "isValid: " + datum2);
						assertFalse(Datum_RegEx.isValid(datum3), errReturnValue + "isValid: " + datum3);
						assertFalse(Datum_RegEx.isValid(datum4), errReturnValue + "isValid: " + datum4);
					}
				}
			}
		}
	}

}
