package ue371_IP4Adresse;

/****************************************************************************************************
 * 
 * TODO iwwas mit ip stuff
 *
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class IP4Adresse_RegEx
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private static final String REGEX_0BIS255   = "([01]?[0-9]{1,2}|2[0-4][0-9]|25[0-5])";
	private static final String REGEX_IPADRESSE = REGEX_0BIS255 + "\\." + REGEX_0BIS255 + "\\." + REGEX_0BIS255 + "\\."
			+ REGEX_0BIS255;
	private int[]               segment = new int[4];

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public IP4Adresse_RegEx(String eingabe)
	{
		if (isValid(eingabe))
		{
			for (int i = 0; i < 4; i++)
			{
				String[] parts = eingabe.split("\\.");
				segment[i] = Integer.parseInt(parts[i]);
			}
		}
		else
			throw new IllegalArgumentException("Eingabe ungültig!");
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public static boolean isValid(String eingabe)
	{
		if (eingabe.isBlank())
			throw new IllegalArgumentException("Eingabe darf nicht null/leer sein!");

		if (eingabe.matches(REGEX_IPADRESSE))
			return true;

		return false;
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	public String getIPAdresse()
	{
		return String.format("%03d.%03d.%03d.%03d", segment[0], segment[1], segment[2], segment[3]);
	}

	public String getIPAdresseBinary()
	{
		String ausgabe = String.format("%8s.%8s.%8s.%8s", to8Bits(segment[0]), to8Bits(segment[1]), to8Bits(segment[2]),
				to8Bits(segment[3]));

		return ausgabe;
	}

	public int[] getIPAdresseSegments()
	{
		return segment;
	}

	public String to8Bits(int eingabe)
	{
		String ausgabe = String.format("%8s", Integer.toBinaryString(eingabe)).replace(' ', '0');

		return ausgabe;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING



	// -------- Ende der Klasse
}
