package ue371_IP4Adresse;

/****************************************************************************************************
 * 
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public interface _IIP4Adresse_RegEx
{

	/** --------------------------------------------------------------------------------<br>
	 * Gibt eine IP4-Adresse in Dezimaldarstellung String zurück, 
	 * wobei die Segment immer mit 0 aufgefüllt werden.
	 * 
	 *  Beispiel: 010.000.000.005 
	 */
	String getIPAdresse();

	/** --------------------------------------------------------------------------------<br>
	 * Gibt eine IP4-Adresse in B#inärdarstellung String zurück, 
	 * wobei die Segment immer mit 0 aufgefüllt werden.
	 * 
	 *  Beispiel: 00001010.00000000.00000000.00000101  
	 */
	String getIPAdresseBinary();

	/** --------------------------------------------------------------------------------<br>
	 * Gibt eine IP4-Adresse als Array mit den einzelnen Segmente zurück 
	 * 
	 *  Beispiel: int[] ip = {10,0,0,5}  
	 */
	int[] getIPAdresseSegments();

	// ----------------------------------------------------------------------------------
	String toString();

}