package ue392_Hardware;

/****************************************************************************************************
 * 
 * TODO iwwas mit Notebooks
 *
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Notebook extends Hardware implements _IIP4_Basics
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private static final String zeroTo255 = "([01]?[0-9]{1,2}|2[0-4][0-9]|25[0-5])";
	private static final String REGEX_IP  = zeroTo255 + "\\." + zeroTo255 + "\\." + zeroTo255 + "\\." + zeroTo255;
	private Prozessor           prozessor;
	private Festplatte          festplatte;
	private String              ip4Adresse;
	private String              ip4Subnet;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Notebook(String bezeichnung, String hersteller, Prozessor prozessor, Festplatte festplatte)
	{
		super(bezeichnung, hersteller);

		if (prozessor == null)
			throw new NullPointerException("Prozessor darf nicht null sein!");
		if (festplatte == null)
			throw new NullPointerException("Festplatte darf nicht null sein!");

		this.prozessor  = prozessor;
		this.festplatte = festplatte;
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public boolean isValidIPAdresse(String eingabe)
	{
		if (eingabe.isBlank())
			throw new IllegalArgumentException("Eingabe ungültig!");

		return eingabe.matches(REGEX_IP);
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	@Override
	public String getAdresse()
	{
		return ip4Adresse;
	}

	@Override
	public String getSubNet()
	{
		return ip4Subnet;
	}

	@Override
	public void setAdresse(String aAddress)
	{
		if (!isValidIPAdresse(aAddress))
			throw new IllegalArgumentException("Ungültige Adresse!");

		ip4Adresse = aAddress;
	}

	@Override
	public void setSubNet(String aSubNetMask)
	{
		if (!isValidIPAdresse(aSubNetMask))
			throw new IllegalArgumentException("Ungültige Adresse!");

		ip4Subnet = aSubNetMask;
	}

	public void setProzessor(Prozessor prozessor)
	{
		this.prozessor = prozessor;
	}

	public Prozessor getProzessor()
	{
		return prozessor;
	}

	public void setFestplatte(Festplatte festplatte)
	{
		this.festplatte = festplatte;
	}

	public Festplatte getFestplatte()
	{
		return festplatte;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Notebook [%s, prozessor=%s, festplatte=%s, ip4Adresse=%s, ip4Subnet=%s]",
				super.toString(), prozessor, festplatte, ip4Adresse, ip4Subnet);
	}


	// -------- Ende der Klasse
}
