package ue392_Hardware;

import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;


/****************************************************************************************************
 * 
 * TODO
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
class _JUT_Hardware
{
	// -------------------------------------------------------------------------------------
	// INSTANZVARIABLEN

	@BeforeEach
	void setUp() throws Exception
	{
		  // Hier nicht benötigt
	}

	
	@Test
	void testProzessor()
	{
		// ------------------------------------------------------------------------------
		// Teste Konstruktor
		assertDoesNotThrow(()->{new Prozessor("i7","Intel",4, 1000);} );
		
		// NULL Pointer exceptions
		assertThrows(NullPointerException.class, ()->{new Prozessor(null,"Intel",4, 1000);} );
		assertThrows(NullPointerException.class, ()->{new Prozessor("i7",null,4, 1000);} );

		// IllegalArguments
		assertThrows(IllegalArgumentException.class, ()->{new Prozessor("","Intel",4, 1000);} );
		assertThrows(IllegalArgumentException.class, ()->{new Prozessor("i7","",4, 1000);} );

		// ------------------------------------------------------------------
		// Kerne prüfen
		for (int i=-1000; i<1000; i++)
		{
			int kerne = i;
			switch (kerne) 
			{
				case 1, 2, 4, 6, 8, 10, 12, 16, 18, 20, 22, 24, 26, 28, 64, 68, 72: 
					assertDoesNotThrow(()->{new Prozessor("i7","Intel",kerne, 1000);} );
					break;
				default: 
					assertThrows(IllegalArgumentException.class, ()->{new Prozessor("i7","intel", kerne, 1000);} );
			}
		}

		// ------------------------------------------------------------------
		// Taktfrequenz prüfen
		for (int i=-1000; i<10000; i++)
		{
			int frequenz = i;
			if (frequenz >= 1000 && frequenz <=5000) 
				assertDoesNotThrow(()->{new Prozessor("i7","Intel",4,frequenz);} );
			else
			    assertThrows(IllegalArgumentException.class, ()->{new Prozessor("i7","intel", 4, frequenz);} );
		}
	}

	@Test
	void testSSD()
	{
		// ------------------------------------------------------------------------------
		// Teste Konstruktor
		assertDoesNotThrow(()->{new SSD("EDO","Samsung", 250, "SATA2", 100);} );
		
		// NULL Pointer exceptions
		assertThrows(NullPointerException.class, ()->{new SSD(null,"Samsung", 250, "SATA2", 100);} );
		assertThrows(NullPointerException.class, ()->{new SSD("EDO",null, 250, "SATA2", 100);} );
		assertThrows(NullPointerException.class, ()->{new SSD("EDO","Samsung", 250, null, 100); });

		// IllegalArguments
		assertThrows(IllegalArgumentException.class, ()->{new SSD("","Samsung", 250, "SATA2", 100);});
		assertThrows(IllegalArgumentException.class, ()->{new SSD("EDO","", 250, "SATA2", 100);});
		assertThrows(IllegalArgumentException.class, ()->{new SSD("EDO","Samsung", 250, "", 100);});

		
		// ------------------------------------------------------------------
		// Schnittstelle prüfen
		assertDoesNotThrow(()->{new SSD("EDO","Samsung", 250, "SATA", 100);}  );
		assertDoesNotThrow(()->{new SSD("EDO","Samsung", 250, "SATA2", 100);}  );
		assertDoesNotThrow(()->{new SSD("EDO","Samsung", 250, "SATA3", 100);}  );
		assertDoesNotThrow(()->{new SSD("EDO","Samsung", 250, "IDE", 100);}  );

		assertThrows(IllegalArgumentException.class, ()->{new SSD("EDO","Samsung", 250, "S", 100);});
		assertThrows(IllegalArgumentException.class, ()->{new SSD("EDO","Samsung", 250, "xyz", 100);});

		
		
		// ------------------------------------------------------------------
		// Kapazität prüfen
		for (int i=-1000; i<12000; i++)
		{
			int kapazitaet = i;
			if (kapazitaet >= 80 && kapazitaet <=12000) 
				assertDoesNotThrow(()->{new SSD("EDO","Samsung", kapazitaet, "IDE", 100);} );
			else
			    assertThrows(IllegalArgumentException.class, ()->{new SSD("EDO","Samsung", kapazitaet, "IDE", 100);} );
		}
		
		// ------------------------------------------------------------------
		// Geschwindigkeit prüfen
		for (int i=-1000; i<20000; i++)
		{
			int geschwindigkeit = i;
			if (geschwindigkeit >= 10 && geschwindigkeit <=1000) 
				assertDoesNotThrow(()->{new SSD("EDO","Samsung", 250, "IDE", geschwindigkeit);} );
			else
			    assertThrows(IllegalArgumentException.class, ()->{new SSD("EDO","Samsung", 250, "IDE", geschwindigkeit);} );
		}
		
		
	}

	
	@Test
	void testNotebook()
	{
		// ------------------------------------------------------------------------------
		// Teste Konstruktor
		SSD hd = new SSD("EDO","Samsung", 250, "SATA2", 100);
		Prozessor cpu = new Prozessor("i7","Intel",4, 1000);
		
		assertDoesNotThrow(()->{new Notebook("Surface", "Microsoft", cpu, hd);} );

		// ------------------------------------------------------------------------------
		// NULL Pointer exceptions
		assertThrows(NullPointerException.class, ()->{new Notebook(null, "Microsoft", cpu, hd);});
		assertThrows(NullPointerException.class, ()->{new Notebook("Surface", null, cpu, hd);});
		assertThrows(NullPointerException.class, ()->{new Notebook("Surface", "Microsoft", null, hd);});
		assertThrows(NullPointerException.class, ()->{new Notebook("Surface", "Microsoft", cpu, null);});
		
		// ------------------------------------------------------------------------------
		// Falsche Argumente
		assertThrows(IllegalArgumentException.class, ()->{new Notebook("", "Microsoft", cpu, hd);});
		assertThrows(IllegalArgumentException.class, ()->{new Notebook("Surface", "", cpu, hd);});

		
		// ------------------------------------------------------------------------------
		// GETTER und SETTER testen
		Notebook nb = new Notebook("Surface", "Microsoft", cpu, hd);
		
		assertEquals("Surface", nb.getBezeichnung());
		assertEquals("Microsoft", nb.getHersteller());
		
		assertEquals(hd, nb.getFestplatte());
		assertEquals(cpu, nb.getProzessor());
	}

	@Test
	void testIP4Basic()
	{
		SSD hd = new SSD("EDO","Samsung", 250, "SATA2", 100);
		Prozessor cpu = new Prozessor("i7","Intel",4, 1000);
		Notebook nb = new Notebook("Surface", "Microsoft", cpu, hd);

		
		// -----------------------------------------------------------------
		// Teste, Interface
		_IIP4_Basics ip = nb;

		assertThrows(NullPointerException.class, ()->{ip.setAdresse(null);});
		assertThrows(IllegalArgumentException.class, ()->{ip.setAdresse("");});
		assertThrows(IllegalArgumentException.class, ()->{ip.setAdresse("10.10.0.256");});
		assertThrows(NullPointerException.class, ()->{ip.setSubNet(null);});
		assertThrows(IllegalArgumentException.class, ()->{ip.setSubNet("");});
		assertThrows(IllegalArgumentException.class, ()->{ip.setSubNet("255.255.255.256");});
		
		
		
		// -----------------------------------------------------------------
		// Teste IP4-Adresse
		ip.setAdresse("10.0.0.1");
		assertEquals("10.0.0.1", ip.getAdresse());

		ip.setSubNet("255.255.255.0");
		assertEquals("255.255.255.0", ip.getSubNet());
		
		
	}


	// -------- Ende der Klasse 
}
