package ue502_TaschenrechnerBinHex;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Font;
import javax.swing.JRadioButton;
import javax.swing.ButtonGroup;
import javax.swing.JLabel;

/****************************************************************************************************
 * 
 * TODO 1+1 != 2; a^2+b^2 = m*c^2; 2! > 29
 *
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class TaschenrechnerBinHex extends JFrame
{
	private double              zahlVorher;
	private JPanel              contentPane;
	private JTextField          txtEingabe;
	private JTextField          txtZwischen;
	private JTextField          txtOpe;
	private final ButtonGroup   buttonGroup  = new ButtonGroup();
	private int                 mode         = 0;                // 0 - dezimal; 1 - binary; 2 - hexadezimal
	private static final String REGEX_BINARY = "[0-1]+";
	private static final String REGEX_HEX    = "[A-F0-9]+";
	private JTextField          txtErgebnisDez;
	private JTextField          txtErgebnisBin;
	private JTextField          txtErgebnisHex;
	private JTextField          txtEingabeDez;
	private JTextField          txtEingabeBin;
	private JTextField          txtEingabeHex;
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen

	/**
	 * Launch the application.
	 */
	public static void main(String[] args)
	{
		EventQueue.invokeLater(new Runnable()
		{
			public void run()
			{
				try
				{
					TaschenrechnerBinHex frame = new TaschenrechnerBinHex();
					frame.setVisible(true);
				} catch (Exception e)
				{
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public TaschenrechnerBinHex()
	{
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 412, 508);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);

		JPanel panel = new JPanel();
		contentPane.add(panel, BorderLayout.CENTER);
		panel.setLayout(null);

		JButton btn_equ = new JButton("=");
		btn_equ.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				solve();
			}
		});
		btn_equ.setBounds(297, 185, 89, 23);
		panel.add(btn_equ);

		txtEingabe = new JTextField();
		txtEingabe.setFont(new Font("Tahoma", Font.PLAIN, 16));
		txtEingabe.setEditable(false);
		txtEingabe.setBounds(226, 0, 160, 38);
		panel.add(txtEingabe);
		txtEingabe.setColumns(10);

		JButton btn_squirt = new JButton("√");
		btn_squirt.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputOperator("√");
			}
		});
		btn_squirt.setBounds(0, 49, 89, 23);
		panel.add(btn_squirt);

		JButton btnDel = new JButton("Del");
		btnDel.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				txtEingabe.setText("");
			}
		});
		btnDel.setBounds(99, 49, 89, 23);
		panel.add(btnDel);

		JButton btnC = new JButton("C");
		btnC.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				txtZwischen.setText("");
				zahlVorher = 0;
				txtEingabe.setText("");
				txtOpe.setText("");
			}
		});
		btnC.setBounds(198, 49, 89, 23);
		panel.add(btnC);

		JButton btn_7 = new JButton("7");
		btn_7.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputKey('7');
			}
		});
		btn_7.setBounds(0, 83, 89, 23);
		panel.add(btn_7);

		JButton btn_8 = new JButton("8");
		btn_8.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputKey('8');
			}
		});
		btn_8.setBounds(99, 83, 89, 23);
		panel.add(btn_8);

		JButton btn_9 = new JButton("9");
		btn_9.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputKey('9');
			}
		});
		btn_9.setBounds(198, 83, 89, 23);
		panel.add(btn_9);

		JButton btn_divi = new JButton("/");
		btn_divi.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputOperator("/");
			}
		});
		btn_divi.setBounds(297, 49, 89, 23);
		panel.add(btn_divi);

		JButton btn_4 = new JButton("4");
		btn_4.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputKey('4');
			}
		});
		btn_4.setBounds(0, 117, 89, 23);
		panel.add(btn_4);

		JButton btn_5 = new JButton("5");
		btn_5.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputKey('5');
			}
		});
		btn_5.setBounds(99, 117, 89, 23);
		panel.add(btn_5);

		JButton btn_6 = new JButton("6");
		btn_6.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputKey('6');
			}
		});
		btn_6.setBounds(198, 117, 89, 23);
		panel.add(btn_6);

		JButton btn_multi = new JButton("*");
		btn_multi.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputOperator("*");
			}
		});
		btn_multi.setBounds(297, 83, 89, 23);
		panel.add(btn_multi);

		JButton btn_1 = new JButton("1");
		btn_1.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputKey('1');
			}
		});
		btn_1.setBounds(0, 151, 89, 23);
		panel.add(btn_1);

		JButton btn_2 = new JButton("2");
		btn_2.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputKey('2');
			}
		});
		btn_2.setBounds(99, 151, 89, 23);
		panel.add(btn_2);

		JButton btn_3 = new JButton("3");
		btn_3.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputKey('3');
			}
		});
		btn_3.setBounds(198, 151, 89, 23);
		panel.add(btn_3);

		JButton btn_minus = new JButton("-");
		btn_minus.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputOperator("-");
			}
		});
		btn_minus.setBounds(297, 117, 89, 23);
		panel.add(btn_minus);

		JButton btnNewButton_16 = new JButton("-/+");
		btnNewButton_16.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputKey('-');
			}
		});
		btnNewButton_16.setBounds(0, 185, 89, 23);
		panel.add(btnNewButton_16);

		JButton btn_0 = new JButton("0");
		btn_0.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputKey('0');
			}
		});
		btn_0.setBounds(99, 185, 89, 23);
		panel.add(btn_0);

		JButton btnNewButton_18 = new JButton(".");
		btnNewButton_18.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputKey('.');
			}
		});
		btnNewButton_18.setBounds(198, 185, 89, 23);
		panel.add(btnNewButton_18);

		JButton btn_plus = new JButton("+");
		btn_plus.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputOperator("+");
			}
		});
		btn_plus.setBounds(297, 151, 89, 23);
		panel.add(btn_plus);

		txtZwischen = new JTextField();
		txtZwischen.setFont(new Font("Tahoma", Font.PLAIN, 16));
		txtZwischen.setEditable(false);
		txtZwischen.setColumns(10);
		txtZwischen.setBounds(0, 0, 160, 38);
		panel.add(txtZwischen);

		txtOpe = new JTextField();
		txtOpe.setFont(new Font("Tahoma", Font.PLAIN, 16));
		txtOpe.setEditable(false);
		txtOpe.setBounds(170, 0, 46, 38);
		panel.add(txtOpe);
		txtOpe.setColumns(10);

		JRadioButton rbtn_Dez = new JRadioButton("Dezimal");
		rbtn_Dez.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				mode = 0;
			}
		});
		buttonGroup.add(rbtn_Dez);
		rbtn_Dez.setSelected(true);
		rbtn_Dez.setBounds(0, 215, 109, 23);
		panel.add(rbtn_Dez);

		JRadioButton rbtn_Bin = new JRadioButton("Binär");
		rbtn_Bin.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				mode = 1;
			}
		});
		buttonGroup.add(rbtn_Bin);
		rbtn_Bin.setBounds(109, 215, 109, 23);
		panel.add(rbtn_Bin);

		JRadioButton rbtn_Hex = new JRadioButton("Hexadezimal");
		rbtn_Hex.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				mode = 2;
				System.out.printf("Text \n");
			}
		});
		buttonGroup.add(rbtn_Hex);
		rbtn_Hex.setBounds(226, 215, 109, 23);
		panel.add(rbtn_Hex);

		JButton btn_a = new JButton("A");
		btn_a.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputKey('A');
			}
		});
		btn_a.setBounds(0, 245, 89, 23);
		panel.add(btn_a);

		JButton btn_b = new JButton("B");
		btn_b.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputKey('B');
			}
		});
		btn_b.setBounds(99, 245, 89, 23);
		panel.add(btn_b);

		JButton btn_c = new JButton("C");
		btn_c.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputKey('C');
			}
		});
		btn_c.setBounds(198, 245, 89, 23);
		panel.add(btn_c);

		JButton btn_d = new JButton("D");
		btn_d.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputKey('D');
			}
		});
		btn_d.setBounds(297, 245, 89, 23);
		panel.add(btn_d);

		JButton btn_e = new JButton("E");
		btn_e.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputKey('E');
			}
		});
		btn_e.setBounds(99, 279, 89, 23);
		panel.add(btn_e);

		JButton btn_f = new JButton("F");
		btn_f.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				inputKey('F');
			}
		});
		btn_f.setBounds(198, 279, 89, 23);
		panel.add(btn_f);

		txtErgebnisDez = new JTextField();
		txtErgebnisDez.setFont(new Font("Tahoma", Font.PLAIN, 16));
		txtErgebnisDez.setEditable(false);
		txtErgebnisDez.setColumns(10);
		txtErgebnisDez.setBounds(80, 313, 160, 38);
		panel.add(txtErgebnisDez);

		JLabel lblDez = new JLabel("Dezimal");
		lblDez.setBounds(10, 327, 46, 14);
		panel.add(lblDez);

		JLabel lblBin = new JLabel("Binär");
		lblBin.setBounds(10, 376, 46, 14);
		panel.add(lblBin);

		txtErgebnisBin = new JTextField();
		txtErgebnisBin.setFont(new Font("Tahoma", Font.PLAIN, 16));
		txtErgebnisBin.setEditable(false);
		txtErgebnisBin.setColumns(10);
		txtErgebnisBin.setBounds(80, 362, 160, 38);
		panel.add(txtErgebnisBin);

		JLabel lblHex = new JLabel("Hexadezimal");
		lblHex.setBounds(10, 425, 60, 14);
		panel.add(lblHex);

		txtErgebnisHex = new JTextField();
		txtErgebnisHex.setFont(new Font("Tahoma", Font.PLAIN, 16));
		txtErgebnisHex.setEditable(false);
		txtErgebnisHex.setColumns(10);
		txtErgebnisHex.setBounds(80, 411, 160, 38);
		panel.add(txtErgebnisHex);

		txtEingabeDez = new JTextField();
		txtEingabeDez.setFont(new Font("Tahoma", Font.PLAIN, 16));
		txtEingabeDez.setEditable(false);
		txtEingabeDez.setColumns(10);
		txtEingabeDez.setBounds(250, 313, 136, 38);
		panel.add(txtEingabeDez);

		txtEingabeBin = new JTextField();
		txtEingabeBin.setFont(new Font("Tahoma", Font.PLAIN, 16));
		txtEingabeBin.setEditable(false);
		txtEingabeBin.setColumns(10);
		txtEingabeBin.setBounds(250, 362, 136, 38);
		panel.add(txtEingabeBin);

		txtEingabeHex = new JTextField();
		txtEingabeHex.setFont(new Font("Tahoma", Font.PLAIN, 16));
		txtEingabeHex.setEditable(false);
		txtEingabeHex.setColumns(10);
		txtEingabeHex.setBounds(250, 411, 136, 38);
		panel.add(txtEingabeHex);
	}

	void inputKey(char aKey)
	{
		String tmp = txtEingabe.getText();
		if (aKey == '-')
			tmp = aKey + tmp;
		else
			tmp = tmp + aKey;
		if (mode == 0)
		{
			try
			{
				if (tmp.equals("0"))
					tmp = "";
				double zahl = Double.parseDouble(tmp);
				txtEingabe.setText(tmp);
				txtEingabeDez.setText(tmp);
				txtEingabeBin.setText(Integer.toBinaryString((int) zahl));
				txtEingabeHex.setText(Integer.toHexString((int) zahl));
			} catch (Exception e2)
			{
				java.awt.Toolkit.getDefaultToolkit().beep();
			}
		}
		else if (mode == 1)
		{
			if (tmp.equals("0"))
				tmp = "";
			if (tmp.matches(REGEX_BINARY))
			{
				txtEingabe.setText(tmp);
				txtEingabeDez.setText(new String("" + Integer.parseInt(txtEingabe.getText(), 2)));
				txtEingabeBin.setText(tmp);
				txtEingabeHex.setText(new String("" + Integer.parseInt(txtEingabe.getText(), 16)));
			}
		}
		else if (mode == 2)
		{
			if (tmp.equals("0"))
				tmp = "";
			if (tmp.matches(REGEX_HEX))
			{
				txtEingabe.setText(tmp);
				txtEingabeDez.setText(new String("" + Integer.parseInt(txtEingabe.getText(), 16)));
				txtEingabeDez.setText(new String("" + Integer.parseInt(txtEingabe.getText(), 16)));
				txtEingabeHex.setText(tmp);
			}
		}
	}

	void inputOperator(String aOperator)
	{
		switch (aOperator)
			{
			case "+", "-", "/", "*", "√":
				zahlVorher = Double.parseDouble(txtEingabe.getText());
				txtZwischen.setText(txtEingabe.getText());
				txtEingabe.setText("");
				txtOpe.setText(aOperator);
				break;
			default:
				java.awt.Toolkit.getDefaultToolkit().beep();
			}
	}

	void solve()
	{
		double zahl1;
		double zahl2;

		if (mode == 0)
		{
			zahl1 = Double.parseDouble(txtZwischen.getText());
			zahl2 = Double.parseDouble(txtEingabe.getText());
		}
		else if (mode == 1)
		{
			zahl1 = Integer.parseInt(txtZwischen.getText(), 2);
			zahl2 = Integer.parseInt(txtEingabe.getText(), 2);
		}
		else
		{
			zahl1 = Integer.parseInt(txtZwischen.getText(), 16);
			zahl2 = Integer.parseInt(txtEingabe.getText(), 16);
		}

		switch (txtOpe.getText())
			{
			case "+":
				zahl1 = zahl1 + zahl2;
				break;
			case "-":
				zahl1 = zahl1 - zahl2;
				break;
			case "/":
				if (zahl2 != 0)
					zahl1 = zahl1 / zahl2;
				break;
			case "*":
				zahl1 = zahl1 * zahl2;
				break;
			case "√":
				if (zahl1 == 2)
					zahl1 = Math.sqrt(zahl2);
				else if (zahl1 == 3)
					zahl1 = Math.cbrt(zahl2);
				break;
			default:
				if (zahl2 != 0)
					zahl1 = zahl2;
			}

		if (mode == 0)
			txtZwischen.setText(Double.toString(zahl1));
		else if (mode == 1)
			txtZwischen.setText(Integer.toBinaryString((int) zahl1));
		else
			txtZwischen.setText(Integer.toHexString((int) zahl1));

		txtErgebnisDez.setText(Double.toString(zahl1));
		txtErgebnisBin.setText(Integer.toBinaryString((int) zahl1));
		txtErgebnisHex.setText(Integer.toHexString((int) zahl1));

		txtOpe.setText("");
		txtEingabe.setText("");
	}
}
