package ue610_Sudoku;

import java.awt.Color;

import sew.G2D;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Zelle
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private static int SIZE        = 50;

	private int        value;
	private int[]      suggestions = new int[9];

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Zelle()
	{
		if (value < 1 || value > 9)
			return;

		for (int i = 0; i < suggestions.length; i++)
		{
			suggestions[i] = (int) Math.random();
		}
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public void paint(int x, int y)
	{
		if (SIZE > 100 || SIZE < 30)
		{
			SIZE = 50;
			G2D.drawString("Invalid size - reset to standart", 22, 22, 20, Color.GRAY, null);
		}

		if (x < 0 || x > 8)
			throw new IllegalArgumentException("Invalid input!");
		if (y < 0 || y > 8)
			throw new IllegalArgumentException("Invalid input!");

		x += 3;
		y += 3;

		int nposx  = x * SIZE - SIZE / 4;
		int nposy  = y * SIZE + SIZE / 4;
		int height = y * SIZE - SIZE / 2;
		int width  = x * SIZE - SIZE / 2;

		G2D.setVisible();

		G2D.drawRect(width, height, SIZE, SIZE, Color.BLACK, this + "R");

		for (int i = 0; i < 9; i++)
		{
			for (int j = 0; j < 9; j++)
			{ // TODO 6 und höher ni untere reihe
				if (suggestions[i] != 0 && suggestions[i] < 6)
					G2D.drawString(String.format("%d", suggestions[i]), (int) (width + i * 8), height + (SIZE / 5),
							SIZE / 4, Color.GRAY, this + "S" + i + "" + j);
				if (suggestions[i] != 0 && suggestions[i] >= 6)
					G2D.drawString(String.format("%d", suggestions[i]), (int) (width + (i - 5) * (SIZE / 5)),
							height + SIZE, SIZE / 4, Color.GRAY, this + "S" + i + "" + j);
			}
		}
		if (value != 0)
			G2D.drawString(String.format("%d", value), nposx, nposy, (int) (SIZE * 0.75), this + "Z");
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	public int getValue()
	{
		return value;
	}

	public void setValue(int value)
	{
		if (value < 0 || value > 9)
			return; // Ignore 'cos invalid
		this.value = value;
	}

	public void setSuggest(int value)
	{
		if (suggestions[value - 1] == value)
			suggestions[value - 1] = 0;
		else
			suggestions[value - 1] = value;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING



	// -------- Ende der Klasse
}
