package ue610_Sudoku02;

import java.awt.Color;

import sew.G2D;

/****************************************************************************************************
 * 
 * TODO Zelle
 *
 * @author Elias Stummer
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Zelle
{
	private static int      g2dId  = 1000;
	public static final int BREITE = 50;
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private int             g2dIdRahmen;
	private int             g2diDText;

	private int             zahl;
	private int             zeile;
	private int             spalte;

	private boolean         selected;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Zelle(int aZeile, int aSpalte)
	{
		if (aZeile < 0 || aZeile > 8)
			throw new IllegalArgumentException("Zeile ungültig.");

		if (aSpalte < 0 || aSpalte > 8)
			throw new IllegalArgumentException("aSpalte ungültig.");

		this.zeile  = aZeile; // Pos der Zelle
		this.spalte = aSpalte;
		setZahl(0); // Feld ist leer.

		g2dIdRahmen = g2dId;
		g2dId++;
		g2diDText = g2dId++; // gleich wie eine zeile oben

	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public void setSelected(boolean selected)
	{
		this.selected = selected;
		paint();
	}

	public boolean getSelected()
	{
		return selected;
	}

	public void paint()
	{
		int x = spalte * BREITE;
		int y = zeile * BREITE;

		if (selected)
			G2D.fillRect(x, y, BREITE, BREITE, Color.BLACK, this + "B");
		else
			G2D.fillRect(x, y, BREITE, BREITE, Color.WHITE, this + "B");

		G2D.drawRect(x, y, BREITE, BREITE, Color.black, g2dIdRahmen);

		String txt = "";
		if (zahl > 0)
			txt = "" + zahl; // Wandle die Zahl in einen String um.

		x += BREITE / 2; // x = x + Breite/2
		y += BREITE / 2;
		G2D.drawString(txt, x, y, 15, Color.BLACK, this + "txt");
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	/**
	 * @return the zahl
	 */
	public int getZahl()
	{
		return zahl;
	}


	/**
	 * @param aZahl the zahl to set
	 */
	public void setZahl(int aZahl)
	{
		if (aZahl < 1 || aZahl > 9)
			return; // ignorieren statt abbrechen.
		zahl = aZahl;
		paint();

	}

	// -------------------------------------------------------------------------------------
	// TOSTRING



	// -------- Ende der Klasse
}
