package ue611_Sudoku;

import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import sew.G2D;

/****************************************************************************************************
 * 
 * TODO
 *
 * @author Prof. Gaisberger version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Sudoku
{
	// -------------------------------------------------------------------------------------
	// Klassenvariablen
	private final static int MAXROWCOL      = 9;

	// -------------------------------------------------------------------------------------
	// INSTANZVARIABLEN
	Zelle[][]                sudoField      = new Zelle[MAXROWCOL][MAXROWCOL];
	Validator[]              validZeilen    = new Validator[MAXROWCOL];
	Validator[]              validSpalten   = new Validator[MAXROWCOL];
	Validator[]              validQuadrants = new Validator[MAXROWCOL];

	Zelle                    selectedCell;


	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR
	public Sudoku()
	{

		// ----------------------------------------------------------
		// Validatoren erstellen
		for (int i = 0; i < MAXROWCOL; i++)
		{
			validZeilen[i]    = new Validator();
			validSpalten[i]   = new Validator();
			validQuadrants[i] = new Validator();
		}


		// ----------------------------------------------------------
		for (int z = 0; z < MAXROWCOL; z++)
		{
			for (int s = 0; s < MAXROWCOL; s++)
			{
				Zelle zelle = new Zelle(z, s);
				sudoField[z][s] = zelle;

				validZeilen[z].add(zelle);
				validSpalten[s].add(zelle);
				validQuadrants[(int) (z / 3) * 3 + (int) (s / 3)].add(zelle);
			}
		}

		G2D.addListener(new MouseAdapter()
		{
			@Override
			public void mouseClicked(MouseEvent aE)
			{
				// TODO Füge hier das Programm der Methode ein
				super.mouseClicked(aE);
				// so kannst du eine Zelle auswählen:
				int z = aE.getY() / 40;
				int s = aE.getX() / 40;

				selectedCell = sudoField[z][s];
				selectedCell.setSelected(true);

			}
		});

		G2D.addListener(new KeyAdapter()
		{

			@Override
			public void keyTyped(KeyEvent aE)
			{
				// TODO Füge hier das Programm der Methode ein
				super.keyTyped(aE);
				int zahl = 0;
				switch (aE.getKeyCode())
					{
					case KeyEvent.VK_1:
						zahl = 1;
						break;
					case KeyEvent.VK_2:
						zahl = 2;
						break;
					case KeyEvent.VK_3:
						zahl = 3;
						break;
					case KeyEvent.VK_4:
						zahl = 4;
						break;
					case KeyEvent.VK_6:
						zahl = 6;
						break;
					case KeyEvent.VK_5:
						zahl = 5;
						break;
					case KeyEvent.VK_7:
						zahl = 7;
						break;
					case KeyEvent.VK_8:
						zahl = 8;
						break;
					case KeyEvent.VK_9:
						zahl = 9;
						break;
					default:
						break;
					}
				// Falls eine Zahl gedrückt wurde, kannst du so prüfen,
				// ob es funktioniert bzw. eine Zahl setzen
				if (isValid(selectedCell.getZeile(), selectedCell.getSpalte(), zahl))
					selectedCell.setZahl(zahl);

			}

		});

		G2D.setVisible();
		paint();
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public void paint()
	{
		for (int z = 0; z < MAXROWCOL; z++)
		{
			for (int s = 0; s < MAXROWCOL; s++)
			{
				sudoField[z][s].paint();
			}
		}
	}



	public boolean isValid(int zeile, int spalte, int zahl)
	{
		if (zeile < 0 || zeile >= MAXROWCOL)
			return false;
		if (spalte < 0 || spalte >= MAXROWCOL)
			return false;

		if (!validZeilen[zeile].isValid(zahl))
			return false;

		if (!validSpalten[spalte].isValid(zahl))
			return false;

		if (!validQuadrants[(int) (zeile / 3) * 3 + (int) (spalte / 3)].isValid(zahl))
			return false;

		return true;
	}


	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	public void setField(int zeile, int spalte, int zahl)
	{
		if (zeile < 0 || zeile >= MAXROWCOL)
			return;
		if (spalte < 0 || spalte >= MAXROWCOL)
			return;

		sudoField[zeile][spalte].setZahl(zahl);
	}

	// -------- Ende der Klasse
}
