package ue611_Sudoku;

import java.util.ArrayList;

/****************************************************************************************************
 * 
 * Liste von Zellen, welche ungleiche Zahen besitzen sollen.
 * 		Zeilen
 * 		Spalten
 * 		Quadranten
 *
 * @author Prof. Gaisberger
 * version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Validator
{

	// -------------------------------------------------------------------------------------
	// INSTANZVARIABLEN
	ArrayList<Zelle> zellen;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR
	public Validator()
	{
		this.zellen = new ArrayList<>();
	}

	/** ---------------------------------------------------------------------------------------<br>
	 * Fügt eine Zelle der Liste hinzu
	 *
	 * @param aZelle
	 */
	public void add(Zelle aZelle)
	{
		this.zellen.add(aZelle);
	}

	/** ---------------------------------------------------------------------------------------<br>
	 * Prüft, ob die Zahl eingefügt werden kann. D.h. noch nicht vorhanden ist.
	 *
	 * @param 	aZahl		Zahl welche geprüft werden soll
	 * @return	true		Zahl ist gültig, kann eingefügt werden
	 * 			false		Zahl ist ungültig, bereits vorhanden
	 */
	public boolean isValid(int aZahl)
	{
		for (Zelle zelle : this.zellen)
			if (zelle.getZahl() == aZahl) return false;

		return true;
	}
}
