package ue611_Sudoku;

import java.awt.Color;

import sew.*;

/****************************************************************************************************
 * 
 * TODO
 *
 * @author Prof. Gaisberger
 * version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------

public class Zelle
{
	// -------------------------------------------------------------------------------------
	// INSTANZVARIABLEN
	private int zeile;
	private int spalte;
	private int zahl;
	private boolean isSelected;

	// -------------------------------------------------------------------------------------
	// Id's für Grafik
	private static long guiId           = 100000;

	private long        guiIdText   = guiId++;
	private long        guiIdRahmen = guiId++;


	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR
	public Zelle(int zeile, int spalte)
	{
		this.zeile  = zeile;
		this.spalte = spalte;
		this.zahl   = 0;
		this.isSelected = false;
		
	}


	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public void paint()
	{
		int width = 40;
		int x     = spalte * width + (int)(spalte/3);
		int y     = zeile * width + (int)(zeile/3);

		if (isSelected)
			G2D.fillRect(x, y, width, width, Color.green, guiIdRahmen);
		else	
			G2D.drawRect(x, y, width, width, Color.BLACK, guiIdRahmen);

		x += width / 2 - 7;
		y += width / 2 + 7;
		String txt = "";
		if (zahl > 0)
			txt = "" + zahl;
		G2D.drawString(txt, x, y, 15, Color.RED, guiIdText);
	}


	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	public int getZahl()
	{
		return zahl;
	}

	public void setZahl(int aZahl)
	{
		if (aZahl < 0 || aZahl > 9)
			return;

		zahl = aZahl;
		paint();
	}

	/**
	 * @param aIsSelected the isSelected to set
	 */
	public void setSelected(boolean aIsSelected)
	{
		isSelected = aIsSelected;
		paint();
	}
	
	/**
	 * @return the zeile
	 */
	public int getZeile()
	{
		return zeile;
	}
	/**
	 * @return the spalte
	 */
	public int getSpalte()
	{
		return spalte;
	}
	
	
	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Zelle [zeile=%s, spalte=%s, zahl=%s]", zeile, spalte, zahl);
	}


	// -------- Ende der Klasse
}
