package ue640_Fraktal;

import java.awt.Color;


/****************************************************************************************************
 * 
 * TODO
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class ColorMap
{
	class Map
	{
		int iteration;
		int r, g, b;

		public Map(int aIteration, int aR, int aG, int aB)
		{
			iteration = aIteration;
			r         = aR;
			g         = aG;
			b         = aB;
		}
	}

	Map[] colors = {
			 new Map(   1, 255, 255, 255),  // Hohe Iterationszahlen sollen hell
			 new Map( 100, 20, 20, 20),  // Hohe Iterationszahlen sollen hell
			 new Map( 300, 210, 210,  40),  // die etwas niedrigeren dunkel
			 new Map( 500, 205,  60,  40),  // die "Spiralen" rot
			 new Map( 850, 120, 140, 255),  // und die "Arme" hellblau werden.
			 new Map(1000,  50,  30, 255),  // Innen kommt ein dunkleres Blau,
			 new Map(1100,   0, 255,   0),  // dann grelles Grün
			 new Map(1997,  20,  70,  20),  // und ein dunkleres Grün.
			 new Map(2000,   0,   0,   0)   // Der Apfelmann wird schwarz.
	};


	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public Color map(int iterationen)
	{
		int i   = getFarbIndex(iterationen);
		if (i < 1 || i > colors.length) return Color.BLACK;

		
		Map min = colors[i - 1];
		Map max = colors[i];

		double iterationsInterval = min.iteration - max.iteration;
		double gewichtetesMittel  = (iterationen - max.iteration) / iterationsInterval;

		int farbInterval = min.r - max.r;
		int r  = (int) (gewichtetesMittel * farbInterval) + max.r;
		
		farbInterval = min.g - max.g;
		int g  = (int) (gewichtetesMittel * farbInterval) + max.g;
		
		farbInterval = min.b - max.b;
		int b  = (int) (gewichtetesMittel * farbInterval) + max.b;

		return new Color(r, g, b);
	}

	
	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	private int getFarbIndex(int iteration)
	{
		for (int i = 1; i < colors.length - 1; i++)
		{
			if (iteration < colors[i].iteration)
				return i;
		}
		return -1;
	}

	// -------- Ende der Klasse
}
