package ue640_Fraktal;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.InputVerifier;
import javax.swing.JLabel;
import javax.swing.JSplitPane;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.ActionEvent;
import javax.swing.JTextField;
import java.awt.Font;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Timer;
import java.util.TimerTask;

/****************************************************************************************************
 * 
 * 1) Frame mit Windowbuilder anlegen 2) Splitpanel hinzufügen 3) resizeWeight
 * auf 0.2 stellen 4) Links ein Panel einfügen und auf absolut Layout stellen 5)
 * Rechts mit Choose Component Fraktal hinzufügen 6) Buttons einfügen
 *
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
@SuppressWarnings("serial")
public class _Main_FraktalSuS extends JFrame
{

	private JPanel     contentPane;
	private JTextField textSize;
	private JTextField textField;
	// -------------------------------------------------------------------------------------
	// KONSTANTEN

	/**
	 * Launch the application.
	 */
	public static void main(String[] args)
	{
		EventQueue.invokeLater(new Runnable()
		{
			public void run()
			{
				try
				{
					_Main_FraktalSuS frame = new _Main_FraktalSuS();
					frame.setVisible(true);
				} catch (Exception e)
				{
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public _Main_FraktalSuS()
	{
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 958, 719);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(new BorderLayout(0, 0));

		JSplitPane splitPane = new JSplitPane();
		splitPane.setResizeWeight(0.2);
		contentPane.add(splitPane);

		JPanel ctrlPanel = new JPanel();
		splitPane.setLeftComponent(ctrlPanel);
		ctrlPanel.setLayout(null);

		Fraktal fraktal = new Fraktal(400, 400);
		fraktal.addKeyListener(new KeyAdapter()
		{
			@Override
			public void keyPressed(KeyEvent e)
			{
				if (e.getKeyCode() == KeyEvent.VK_S)
				{
					fraktal.save(
							"Z:\\SEW\\Eclipse\\WORKSPACE\\_git.htltraun.at\\spassmitsew\\SEW3_git\\src\\_Images\\s_gedrueckt.png");
				}
				else if (e.getKeyCode() == KeyEvent.VK_PLUS)
				{
					fraktal.zoomIn();
				}
				else if (e.getKeyCode() == KeyEvent.VK_MINUS)
				{
					fraktal.zoomOut();
				}
				else if (e.getKeyCode() == KeyEvent.VK_RIGHT)
				{
					fraktal.moveRight();
				}
				else if (e.getKeyCode() == KeyEvent.VK_LEFT)
				{
					fraktal.moveLeft();
				}
				else if (e.getKeyCode() == KeyEvent.VK_UP)
				{
					fraktal.moveUp();
				}
				else if (e.getKeyCode() == KeyEvent.VK_DOWN)
				{
					fraktal.moveDown();
				}
				
				
			}
		});
		fraktal.addMouseListener(new MouseAdapter()
		{
			@Override
			public void mouseClicked(MouseEvent e)
			{
				if (e.getButton() == MouseEvent.BUTTON1)
				{
					fraktal.setOrigin(e.getX(), e.getY());
					fraktal.zoomIn();
				}
				else if (e.getButton() == MouseEvent.BUTTON3)
					fraktal.zoomOut();
			}
		});
		splitPane.setRightComponent(fraktal);

		// von Lian
		new Timer().schedule(new TimerTask()
		{

			@Override
			public void run()
			{
				fraktal.requestFocus();
			}
		}, 1000, 1000);


		JButton btnZoomIn = new JButton("Zoom In");
		btnZoomIn.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				fraktal.zoomIn();
			}
		});
		btnZoomIn.setFont(new Font("Tahoma", Font.PLAIN, 10));
		btnZoomIn.setBounds(10, 11, 86, 23);
		ctrlPanel.add(btnZoomIn);

		JButton btnGrow = new JButton("Grow");
		btnGrow.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				fraktal.sizeUp();
				fraktal.berechneBild();
			}
		});
		btnGrow.setFont(new Font("Tahoma", Font.PLAIN, 10));
		btnGrow.setBounds(95, 11, 81, 23);
		ctrlPanel.add(btnGrow);

		JButton btnZoomOut = new JButton("Zoom Out");
		btnZoomOut.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				fraktal.zoomOut();
			}
		});
		btnZoomOut.setFont(new Font("Tahoma", Font.PLAIN, 10));
		btnZoomOut.setBounds(10, 45, 86, 23);
		ctrlPanel.add(btnZoomOut);

		JButton btnShrink = new JButton("Shrink");
		btnShrink.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				fraktal.sizeDown();
				fraktal.berechneBild();
			}
		});
		btnShrink.setFont(new Font("Tahoma", Font.PLAIN, 10));
		btnShrink.setBounds(95, 45, 81, 23);
		ctrlPanel.add(btnShrink);

		JButton btnUp = new JButton("Up");
		btnUp.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				fraktal.moveUp();
			}
		});
		btnUp.setBounds(53, 101, 78, 23);
		ctrlPanel.add(btnUp);

		JButton btnLeft = new JButton("Left");
		btnLeft.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				fraktal.moveLeft();
			}
		});
		btnLeft.setBounds(10, 135, 78, 23);
		ctrlPanel.add(btnLeft);

		JButton btnRight = new JButton("Right");
		btnRight.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				fraktal.moveRight();
			}
		});
		btnRight.setBounds(95, 135, 78, 23);
		ctrlPanel.add(btnRight);

		JButton btnDown = new JButton("Down");
		btnDown.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				fraktal.moveDown();
			}
		});
		btnDown.setBounds(53, 169, 78, 23);
		ctrlPanel.add(btnDown);

		JButton btnSize300 = new JButton("Size 300");
		btnSize300.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				fraktal.setSize(300, 300);
				fraktal.berechneBild();
			}
		});
		btnSize300.setFont(new Font("Tahoma", Font.PLAIN, 10));
		btnSize300.setBounds(10, 230, 81, 23);
		ctrlPanel.add(btnSize300);

		JButton btnSize1000 = new JButton("Size 1000");
		btnSize1000.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				fraktal.setSize(1000, 1000);
				fraktal.berechneBild();
			}
		});
		btnSize1000.setFont(new Font("Tahoma", Font.PLAIN, 10));
		btnSize1000.setBounds(10, 253, 81, 23);
		ctrlPanel.add(btnSize1000);

		JButton btnSize2000 = new JButton("Size 2000");
		btnSize2000.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				fraktal.setSize(2000, 2000);
				fraktal.berechneBild();
			}
		});
		btnSize2000.setFont(new Font("Tahoma", Font.PLAIN, 10));
		btnSize2000.setBounds(92, 253, 81, 23);
		ctrlPanel.add(btnSize2000);

		JButton btnSet = new JButton("Set");
		btnSet.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				try
				{
					int x = Integer.parseInt(textField.getText());

					fraktal.setSize(x, x);
				} catch (NumberFormatException f)
				{
					System.out.printf("Kein gültiger Int \n");
				}

				fraktal.berechneBild();
			}
		});
		btnSet.setBounds(119, 287, 54, 23);
		ctrlPanel.add(btnSet);

		textField = new JTextField();
		textField.setBounds(48, 288, 61, 20);
		ctrlPanel.add(textField);
		textField.setColumns(10);

		JLabel lblNewLabel = new JLabel("Size");
		lblNewLabel.setBounds(10, 291, 46, 14);
		ctrlPanel.add(lblNewLabel);

		JButton btnSave = new JButton("Save");
		btnSet.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				fraktal.save(
						"Z:\\SEW\\Eclipse\\WORKSPACE\\_git.htltraun.at\\spassmitsew\\SEW3_git\\src\\_Images\\fraktal.png");
			}
		});
		btnSave.setFont(new Font("Tahoma", Font.PLAIN, 10));
		btnSave.setBounds(87, 345, 86, 23);
		ctrlPanel.add(btnSave);

	}
}
