package ue100_FahrzeugBesser;

import sew.G2D;

/****************************************************************************************************
 * 
 * TODO Super Fahrzeug für Vererbung
 *
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Fahrzeug
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String fin;
	private String marke;
	private char   treibstoff;
	private double vAktuell;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Fahrzeug(String fin, String marke, char treibstoff)
	{
		if (fin == null)
			throw new NullPointerException("fin darf nicht null sein!");
		if (fin == "")
			throw new IllegalArgumentException("fin darf nicht leer sein!");
		if (marke == null)
			throw new NullPointerException("marke darf nicht null sein!");
		if (marke == "")
			throw new IllegalArgumentException("marke darf nicht leer sein!");

		setTreibstoff(treibstoff);

		this.fin      = fin;
		this.marke    = marke;
		this.vAktuell = 0;
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public void paint(int x, int y)
	{
		G2D.setVisible();

		G2D.drawImage("src\\_images\\moped.png", x, y, 100, 0, null);
	}

	public double beschleunigen(double a, double t)
	{
		if (t < 0)
			throw new IllegalArgumentException("t muss > 0 sein!");
		if (a < 0)
			throw new IllegalArgumentException("a muss > 0 sein!");
		if (vAktuell + a * t > 299792458)
			throw new IllegalArgumentException("Bissl zu schnell!!");
		return vAktuell = vAktuell + a * t;
	}

	public double bremsen(double a, double t)
	{
		if (t < 0)
			throw new IllegalArgumentException("t muss > 0 sein!");
		if (a < 0)
			throw new IllegalArgumentException("a muss > 0 sein!");
		if (vAktuell - a * t < 0)
			return 0;
		return vAktuell = vAktuell - a * t;
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	public char getTreibstoff()
	{
		return treibstoff;
	}

	public void setTreibstoff(char treibstoff)
	{
		if (treibstoff != 'S' && treibstoff != 'D')
			throw new IllegalArgumentException("treibstoff muss 'S' oder 'D' sein!");

		this.treibstoff = treibstoff;
	}

	public String getFin()
	{
		return fin;
	}

	public String getMarke()
	{
		return marke;
	}

	public double getvAktuell()
	{
		return vAktuell;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Fahrzeug [fin=%s, marke=%s, treibstoff=%s, vAktuell=%s]", fin, marke, treibstoff,
				vAktuell);
	}
}
// -------- Ende der Klasse