package ue100_Fahrzeuge;

import sew.G2D;

/****************************************************************************************************
 * 
 * TODO Gemeinsames Programmieren; Konstruktor, Methoden, Copy-Paste Auto +
 * Änderungen, ...
 *
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Auto
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String fin;
	private String marke;
	private char   treibstoff;
	private double vAktuell;
	private char   bauart;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Auto(String fin, String marke, char treibstoff, char bauart)
	{
		if (fin == null)
			throw new NullPointerException("fin darf nicht null sein!");
		if (fin == "")
			throw new IllegalArgumentException("fin darf nicht leer sein!");
		if (marke == null)
			throw new NullPointerException("marke darf nicht null sein!");
		if (marke == "")
			throw new IllegalArgumentException("marke darf nicht leer sein!");
		if (bauart != 'L' && bauart != 'K')
			throw new IllegalArgumentException("bauart muss 'L' oder 'K' sein!");

		setTreibstoff(treibstoff);

		this.fin      = fin;
		this.marke    = marke;
		this.bauart   = bauart;
		this.vAktuell = 0;
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public void paint(int x, int y)
	{
		G2D.setVisible();

		G2D.drawImage("src\\_images\\honda.png", x, y, 100, 0, null);
	}

	public double beschleunigen(double a, double t)
	{
		if (t < 0)
			throw new IllegalArgumentException("t muss > 0 sein!");
		return vAktuell = vAktuell + a * t;
	}

	public double bremsen(double a, double t)
	{
		if (t < 0)
			throw new IllegalArgumentException("t muss > 0 sein!");
		if (vAktuell - a * t < 0)
			return 0;
		return vAktuell = vAktuell - a * t;
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	public char getTreibstoff()
	{
		return treibstoff;
	}

	public void setTreibstoff(char treibstoff)
	{
		if (treibstoff != 'S' && treibstoff != 'D')
			throw new IllegalArgumentException("treibstoff muss 'S' oder 'D' sein!");

		this.treibstoff = treibstoff;
	}

	public String getFin()
	{
		return fin;
	}

	public String getMarke()
	{
		return marke;
	}

	public double getvAktuell()
	{
		return vAktuell;
	}

	public char getBauart()
	{
		return bauart;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Auto [fin=%s, marke=%s, treibstoff=%s, vAktuell=%s, bauart=%s]", fin, marke, treibstoff,
				vAktuell, bauart);
	}

	// -------- Ende der Klasse
}
