package ue100_Fahrzeuge;

import sew.G2D;

/****************************************************************************************************
 * 
 * TODO Konstruktor, Methoden, Copy-Paste Auto + Änderungen, ...
 *
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Motorrad
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String fin;
	private String marke;
	private char   treibstoff;
	private double vAktuell;
	private double leistung;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Motorrad(String fin, String marke, char treibstoff, double leistung)
	{
		if (fin == null)
			throw new NullPointerException("fin darf nicht null sein!");
		if (fin == "")
			throw new IllegalArgumentException("fin darf nicht leer sein!");
		if (marke == null)
			throw new NullPointerException("marke darf nicht null sein!");
		if (marke == "")
			throw new IllegalArgumentException("marke darf nicht leer sein!");
		if (leistung <= 0)
			throw new IllegalArgumentException("leistung darf nicht <= 0 sein!");

		setTreibstoff(treibstoff);

		this.fin      = fin;
		this.marke    = marke;
		this.leistung = leistung;
		this.vAktuell = 0;
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public void paint(int x, int y)
	{
		G2D.setVisible();

		G2D.drawImage("src\\_images\\motorrad.png", x, y, 100, 0, null);
	}

	public double beschleunigen(double a, double t)
	{
		if (t < 0)
			throw new IllegalArgumentException("t muss > 0 sein!");
		return vAktuell = vAktuell + a * t;
	}

	public double bremsen(double a, double t)
	{
		if (t < 0)
			throw new IllegalArgumentException("t muss > 0 sein!");
		if (vAktuell - a * t < 0)
			return 0;
		return vAktuell = vAktuell - a * t;
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	public char getTreibstoff()
	{
		return treibstoff;
	}

	public void setTreibstoff(char treibstoff)
	{
		if (treibstoff != 'S' && treibstoff != 'D')
			throw new IllegalArgumentException("treibstoff muss 'S' oder 'D' sein!");

		this.treibstoff = treibstoff;
	}

	public String getFin()
	{
		return fin;
	}

	public String getMarke()
	{
		return marke;
	}

	public double getvAktuell()
	{
		return vAktuell;
	}

	public double getLeistung()
	{
		return leistung;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Motorrad [fin=%s, marke=%s, treibstoff=%s, vAktuell=%s, leistung=%s]", fin, marke,
				treibstoff, vAktuell, leistung);
	}

	// -------- Ende der Klasse
}
