package ue241_HerrDerRinge;

import sew.G2D;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Daniel Hamm
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public abstract class Wesen
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String name;
	private int    staerke;
	private String waffe;
	private Wesen  freundVon;
	private int    x;
	private int    y;
	private String picture;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Wesen(String name, int staerke, String waffe)
	{
		if (name == null)
			throw new NullPointerException("Name darf nicht null sein!");
		if (name.equals(""))
			throw new IllegalArgumentException("Name darf nicht leer sein!");
		this.name = name;
		setStaerke(staerke);
		setWaffe(waffe);
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public abstract void kaempfen();

	public abstract void schlafen();

	public abstract void laufen();

	public void paint()
	{
		G2D.setVisible();

		G2D.drawImage(picture, x, y, this);
	}

	public void paint(int x, int y)
	{
		G2D.setVisible();

		G2D.drawImage(picture, x, y, this);
	}

	public void moveTo(int x, int y, int z)
	{
		paint(x, y);
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	public String getName()
	{
		return name;
	}

	public int getStaerke()
	{
		return staerke;
	}

	public void setStaerke(int staerke)
	{
		if (staerke <= 0)
			throw new IllegalArgumentException("Staerke darf nicht kleiner 0 sein!");
		this.staerke = staerke;
	}

	public String getWaffe()
	{
		return waffe;
	}

	public void setWaffe(String waffe)
	{
		if (waffe == null)
			throw new NullPointerException("Waffe darf nicht null sein!");
		if (waffe.equals(""))
			throw new IllegalArgumentException("Waffe darf nicht leer sein!");
		this.waffe = waffe;
	}

	public Wesen getFreundVon()
	{
		return freundVon;
	}

	public void setFreundVon(Wesen wesen)
	{
		this.freundVon = wesen;
	}

	public void setPicture(String picture)
	{
		if (picture == null)
			throw new NullPointerException("picure darf nicht null sein!");
		if (picture.equals(""))
			throw new IllegalArgumentException("picture darf nicht leer sein!");
		this.picture = picture;
	}

	public int getX()
	{
		return x;
	}

	public void setX(int x)
	{
		if (x < 0 || x > 800)
			throw new IllegalArgumentException("x muss zwischen 0 und 800 sein!");
		this.x = x;
	}

	public int getY()
	{
		return y;
	}

	public void setY(int y)
	{
		if (y < 0 || y > 800)
			throw new IllegalArgumentException("x muss zwischen 0 und 800 sein!");
		this.y = y;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("e");
	}


	// -------- Ende der Klasse
}
