package ue241_HerrDerRinge;

import java.util.ArrayList;


/****************************************************************************************************
 * 
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public interface _IFilmFiguren
{

	/** --------------------------------------------------------------------------------<br>
	 * Eine neue Wesen wird in die Liste der Filmfiguren hinzugefügt 
	 * 
	 * @param aWesen		Referenz auf das Wesen, welches hinzugefügt werden soll
	 */
	void neueSpielfigur(Wesen aWesen);

	/** --------------------------------------------------------------------------------<br>
	 * Prüft, ob ein Wesen in der Liste der Filmfiguren bereits vorhanden ist.
	 * 
	 * @param aWesen	Referenz auf das Wesen, welches gesucht werden soll
	 * @return			true, falls im Filmfiguren gefunden
	 */
	boolean istInDerListe(Wesen aWesen);

	/** --------------------------------------------------------------------------------<br>
	 * Wenn ein Wesen getötet, etc wird, muss es aus der Liste der Filmfiguren entfernt werden.
	 * 
	 * @param aWesen	Referenz auf das Wesen, welches entfernt werden soll
	 */
	void entferne(Wesen aWesen);

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Wesen in der Konsole ausgeben
	 */
	void printAlleFiguren();

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Hobbits in der Konsole ausgeben
	 */
	void printHobbitListe();

	/** --------------------------------------------------------------------------------<br>
	 * Alle Figuren an eine zufällige Position zeichnen
	 */
	void paintAlleFigurenRandom();

	/** --------------------------------------------------------------------------------<br>
	 * Alle Figuren an eine zufällige Position bewegen
	 */
	void moveAlleFigurenRandom();

	/** --------------------------------------------------------------------------------<br>
	 * Alle Wesen in Filmfiguren laufen lassen
	 */
	void alleFigurenLaufen();

	/** --------------------------------------------------------------------------------<br>
	 * Alle Wesen in Filmfiguren kämpfen lassen
	 */
	void alleFigurenKaempfen();

	/** --------------------------------------------------------------------------------<br>
	 * Alle Hobbits verstecken sich
	 * 
	 */
	void mitHobbitsVersteckenSich();

	/** --------------------------------------------------------------------------------<br>
	 * Alle Zauberer zaubern
	 * 
	 */
	void alleZaubererZaubern();

	/** --------------------------------------------------------------------------------<br>
	 * Alle Orks streiten
	 * 
	 */
	void alleOrksStreiten();

	/** --------------------------------------------------------------------------------<br>
	 * Ermittelt die Anzahl der Wesen einer bestimmten Art.
	 * 
	 * @return  Anzahl der Wesen einer bestimmten Art
	 */
	int getAnzOrks();

	int getAnzZwergeUndHobbits();

	/** --------------------------------------------------------------------------------<br>
	 * Ermittelt die Anzahl aller Wesen ohne Orks
	 * 
	 * @return  Anzahl der Wesen ohne Orks
	 */
	int getAnzFigurenOhneOrks();

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Zauberer im Filmfiguren
	 * 
	 * @return	Liste aller Zauberer
	 */
	ArrayList<Zauberer> getZauberer();

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Hobbits im Filmfiguren
	 * 
	 * @return	Liste aller Hobbits
	 */
	ArrayList<Hobbit> getHobbits();

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Orks im Filmfiguren
	 * 
	 * @return	Liste aller Orks
	 */
	ArrayList<Ork> getOrks();

	/** --------------------------------------------------------------------------------<br>
	 * Sucht das Wesen mit einem bestimmten Namen.
	 *
	 * @param aName		Name des Wesen
	 * @return			gefundenes Wesen oder null wenn nicht gefunden
	 */
	Wesen getWesen(String aName);

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Gutwesen (Keine Orks!) mit einer Mindeststärke
	 * Gutwesen sind alle Wesen, außer Orks!
	 *
	 * @param 	aStaerke	Stärke, welche die Gutwesen mindestens besitzen müssen
	 * @return				Liste aller gefundenen Wesen mit einer höheren Kampfstärke
	 */
	ArrayList<Wesen> getGutWesenMitMindestStaerke(int aStaerke);

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Wesen, welche Freunde eines anderen Wesen sind
	 * 
	 * ACHTUNG: Ist ein Wesen bereits als Freund eingetragen, darf er 
	 * 			KEIN ZWEITESMAL mehr eingetragen werden
	 * 
	 * @return		Liste aller gefundenen Wesen, welche als Freunde bei einem anderen
	 * 				Wesen eingetragen sind
	 */
	ArrayList<Wesen> getWesenDieFreundeSind();

}